unit ugomain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Keyboard, LCLType, Buttons, StdCtrls, Menus, ComCtrls, MMSystem, types,
  WinCRT, Math;

type
  coords=record //just a pair of coords
    x,y:integer;
  end;
  popup = record
    x:real;
    y:real;
    text:string;
    active:boolean;
    ord:integer; //ord is equal to last created popup index (global lpop var)
  end;

  cage = record
    p:integer; //amount of product
    m:integer; //amount of money
    o:integer; //owner's id
    b:integer; //building ID
    t:integer; //tile ID
  end;
  fleet = record
    power:integer; //power of fleet
    owner:integer; //owner of fleet
    ap:integer;    //ap of fleet
    id:integer;    //equivalent to number of fleet in array
    x,y:integer;
    xp,level:integer;
    ab,db:real;
    admiral:string;
    battleships:integer;
  end;
  player=record
    color:TColor;
    fleetcost:Integer; //cost of a new fleet
    rfleetcost:real;   //ACTUAL fleet cost
    human:boolean;
    name:string;
    team:integer;
    tech:array[0..10]of integer;
    sperc:integer;
  end;
  cmobj=record
    tp:integer; //0 - none; 1 - ship; 2 - missile; 3 - beam
    hp:integer;
    alive:boolean;
    color:TColor;
    x1,y1:integer;
    orient:integer;
    dmbonus,defbouns:real;
    //for beams only
    x2,y2:integer;
    //missile params
    kx,ky:real;
    xr,yr:real;
    tid:integer;
    tx,ty:integer; //target coordinates
    spd:real;
    animframe:integer;
    animstep:integer;
    owner:integer;
    shield:integer;
    ctid:integer;
    hptxt:string;
  end;
  gbtn=record
    x1,y1,x2,y2:integer;
    chm:integer; //chamfer radius
    id:integer;  //index for checkbutton
    state:integer; //0 - normal, 1 - active, 2 - pressed
    visible:boolean;
    text:string;
    cb,cbc:boolean;
  end;

  { TForm1 }

  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    PopupMenu1: TPopupMenu;
    SaveDialog1: TSaveDialog;
    SpeedButton1: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton15: TSpeedButton;
    SpeedButton16: TSpeedButton;
    SpeedButton17: TSpeedButton;
    SpeedButton71: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton70: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    Timer1: TTimer;
    TrackBar1: TTrackBar;
    procedure CheckForBS(x,y,atp:integer);
    procedure constructbuilding(bcx,bcy,blid,pl:integer);
    procedure deconstructbuilding(bcx,bcy,blid,pl:integer);
    procedure MenuItem8Click(Sender: TObject);
    procedure Showbriefing(bfn:string;lng:integer);
    procedure AddBattleship(fid:integer);
    procedure FormActivate(Sender: TObject);
    Procedure GButtonPress(bid:integer);
    procedure Image1DblClick(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem6Click(Sender: TObject);
    procedure MenuItem7Click(Sender: TObject);
    procedure ResearchTech(pl,tch:integer);
    procedure AIForcedMoveFleet(gx,gy:integer;flt:fleet);
    function  GetNearestIntruder(fch:fleet;rad:integer):fleet;
    procedure DrawCombat(cnvf:TCanvas;xf,yf:integer;ww,wh:integer);
    procedure MenuItem4Click(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure SaveGame(fn:string);
    procedure LoadGame(fn:string);
    procedure ShowBattle(p1,bs1,r1:integer;ab1,db1:real;c1:TColor;a1,id1:integer;
                         p2,bs2,r2:integer;ab2,db2:real;c2:TColor;a2,id2:integer;
                         turn:integer);
    procedure SetGameScl(k:integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormResize(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure Image1MouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure Image1MouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure Log(s:string);
    function getmyfleetno(p:integer):integer;
    function getaveragefleetno:integer;
    procedure MenuItem3Click(Sender: TObject);
    function playerhasfleets(p:integer):boolean;
    procedure AudioNote(id:integer);
    procedure CheckBox2Change(Sender: TObject);
    function getstrongestnearbyfleet(x,y,p:integer):fleet;
    procedure AIMoveFleetToNearestClaimed(fx,fy,pf:integer);
    procedure AIMoveConcerningEnemyFleet(pflt,eflt:fleet);
    procedure AIMoveFleetToNearestUnclaimed(fx,fy,pf:integer);
    procedure ProcessAITurns;
    function PlayerHasCages(p:integer):boolean;
    procedure CheckBox1Change(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton11Click(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
    procedure SpeedButton13Click(Sender: TObject);
    procedure SpeedButton14Click(Sender: TObject);
    procedure SpeedButton15Click(Sender: TObject);
    procedure SpeedButton16Click(Sender: TObject);
    procedure SpeedButton17Click(Sender: TObject);
    procedure SpeedButton17DblClick(Sender: TObject);
    procedure SpeedButton71Click(Sender: TObject);
    procedure SpeedButton70Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure WinCheck;
    procedure MenuItem2Click(Sender: TObject);
    procedure startgame(tp:integer; rc:boolean; mp,pp:integer);
    procedure ShowMMenu;
    procedure cleangamedata;
    procedure SpeedButtonClick(Sender: TObject);
    procedure UpgradeFleet(fid:integer);
    procedure SpeedButton6Click(Sender: TObject);
    procedure UpgradeTile(utx,uty:integer);
    procedure BuildNewFleet(x,y,p,fc:integer);
    procedure MoveFleet(flt,kx,ky:integer);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    function TileHasNearbyClaimed(tx,ty,p:integer):boolean;
    procedure ClaimCage(claimingfleet:fleet);
    procedure FormCreate(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer
      );
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Redraw;
    procedure EndTurn;
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Image1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  basloc:integer;
  field:array[0..99,0..99]of cage;
  fleets:array[1..4000]of fleet;
  battlefleet:array[0..32000]of cmobj;
  missiles:array[0..32000]of cmobj;
  beams:array[0..32000]of cmobj;
  plasma:array[0..32000]of cmobj;
  //battlefleet:array[0..32000]of cmobj;
  plr:array[0..10]of player;
  sships:array[1..100]of bitmap;


  fac:integer=0;
  //current turn
  turn:integer=1;
  //current battle turn
  bt:integer=0;
  //field width and height, scale
  gw:integer=1;
  gh:integer=1;
  scl:integer=1;
  //camera position
  camx:integer=0;
  camy:integer=0;
  mxp:integer=0;
  myp:integer=0;
  //active fleet id
  afleet:integer=1;
  //active cage coords
  acagex:integer=0;
  acagey:integer=0;
  //active player
  apl:integer=0;
  //max number of players
  maxpl:integer=1;
  //current product price
  pprice,minpprice,maxpprice,prflux:integer;

  globalbmp:TBitmap;
  globalpng:TPortableNetworkGraphic;
  moneypool:array[0..10]of integer;
  productpool:array[0..10]of integer;
  tx,ty:integer; //target coordinates of fleet movement
  cx,cy:integer; //click coordinates in gaming scale
  ctx,cty:integer; //fleet move target
  cmkx,cmky:integer; //fleet move with mouse coeffs
  pop:array[0..100]of popup; //array of floating popups
  lpop:integer=1; //index number of popups
  maxf:integer; //maximal active fleet
  techsloaded:boolean=false; //are technology icons loaded?

  mm:boolean=true; //indicates menu mode
  cm:boolean=false; //indicates combat display mode
  ego:boolean=false; //show player as green and enemies as red
  dsp:boolean=true; //display sector params
  ig:boolean=true; //indicates if someone launch a game

  //Advanced mechanics
  flcm:real=2;
  bassp:real=1;
  bassecm:real=1;
  basflap:real=1;
  basflp:real=1;
  basfsm:real=1;
  ballowrandom:boolean=false;
  sfcm:integer=10;
  sfcp:integer=10;
  fpowlim:integer=50;
  smplim:integer=10;
  bbasedmg:integer=20;
  bbdmg:integer=60;
  bbasehp:integer=100;
  bclpc:integer=0; //cage claim in prod
  bclmc:integer=10; //cage claim in money
  bssmlt:integer=1;
  barc:integer=10000;//basic research cost in money
  btechlim:integer=10;//limit of tech level
  bnouselesssectors:boolean=false;
  bbslim:integer=5;
  bbscostm:integer=1300;
  bbscostp:integer=500;
  bbsmult:real=1.5;
  bbssuppcst:integer=50;
  bbshpmult:real=10;
  bbprodsc:real=1;//cost of single product unit creation
  viccond:integer; //
  //VICTORY CONDITIONS: 1 - by capture sector; 2 - by defeat fleet; 3 - by survive for; other - by conquest
  vc_x,vc_y,vc_id,vc_t:integer; //vars for corresponding vic types
  briefid,gbriefid:string; //identifiers of briefing files
  nmid:string; //next mission filename
  ballowbriefings:boolean=false;

  //Battle display passed params
  bp1,bp2,bpf1,bpf2:integer;
  bab1,bab2,bdb1,bdb2:real;
  bc1,bc2:TColor;
  bp1r,bp2r:integer;
  bxr,byr:array[0..32000]of real;
  as1,as2:integer;
  et:integer;
  sr:boolean;
  bfw:integer=1920;
  bfh:integer=1080;
  bfscl:real; //scale for battlefield
  bbgn:integer;
  cbt1,cbt2:integer;
  bselship:integer;
  maxo:integer;
  bpause:boolean=false;


  //decorative
  names:array[0..10000]of string;
  titles:array[0..10000]of string;
  ranks:array[0..10000]of string;
  nn,tn,rn:integer;
  strarr:array[1..10000]of string;
  cloc:integer=-1;

  //sprites
  spritesl:array[1..1000]of TPortableNetworkGraphic;
  spritesr:array[1..1000]of TPortableNetworkGraphic;
  bsspritesl:array[1..1000]of TPortableNetworkGraphic;
  bsspritesr:array[1..1000]of TPortableNetworkGraphic;
  spritesexpl:array[1..7]of TPortableNetworkGraphic;
  vtiles:array[1..1000]of TPortableNetworkGraphic;
  sno:integer=0;
  backgrounds:array[1..1000]of TPortableNetworkGraphic;
  bgno:integer=0;
  tlno:integer=0;

  //buttons
  buts:array[1..20]of gbtn;

  //new game menu vars
  camparr:array[0..100000]of string;

implementation

{$R *.lfm}

{ TForm1 }

uses unewgame,ustat,utrade,usyslog, ulocale, ulpick, ubattleinfo,usaveload2,
     umaped,ubriefing,unewgame2;

//function getprod

function GetFP(flt:fleet):integer;
begin
  result:=round(flt.power+(flt.battleships*bbshpmult));
end;

Procedure TForm1.GButtonPress(bid:integer);
begin
  //presses a picked button
  case bid of
  1:begin
      SpeedButton3.Click;
    end;
  2:begin
      SpeedButton2.Click;
    end;
  3:begin
      SpeedButton1.Click;
    end;
  4:begin
      SpeedButton6.Click;
    end;
  5:begin
      SpeedButton16.Click;
    end;
  6:begin
      SpeedButton7.Click;
    end;
  7:begin
      SpeedButton5.Click;
    end;
  8:begin
      if CheckBox1.Checked=false then CheckBox1.Checked:=true else CheckBox1.Checked:=false;
    end;
  9:begin
      if CheckBox2.Checked=false then CheckBox2.Checked:=true else CheckBox2.Checked:=false;
    end;
 10:begin
      if CheckBox3.Checked=false then CheckBox3.Checked:=true else CheckBox3.Checked:=false;
    end;
 11:begin
      if CheckBox4.Checked=false then CheckBox4.Checked:=true else CheckBox4.Checked:=false;
    end;
 12:begin
      if CheckBox5.Checked=false then CheckBox5.Checked:=true else CheckBox5.Checked:=false;
    end;
 13:begin
      MenuItem1.Click;
    end;
 14:begin
      SpeedButton4.Click;
    end;
 15:begin
      SpeedButton17.Click;
    end;
 16:begin
      if CheckBox6.Checked=false then CheckBox6.Checked:=true else CheckBox6.Checked:=false;
    end;
 17:begin
      Form13.Show;
    end;
 18:begin
      mm:=false;
      if SaveDialog1.Execute then SaveGame(SaveDialog1.FileName);
    end;
 19:begin
      mm:=false;
      If OpenDialog1.Execute then LoadGame(OpenDialog1.FileName);
    end;
 20:begin
      halt;
    end;
  end;
end;

function checkforbutton(x,y:integer):integer;
var i,r:integer;
begin
  r:=0;
  for i:=1 to 20 do
  begin
    if (x>=buts[i].x1) and (x<=buts[i].x2) and (y>=buts[i].y1) and (y<=buts[i].y2) and
       (buts[i].visible=true) then
    begin
      r:=buts[i].id;
    end;
  end;
  Result:=r;
end;

function checkforfleet(x,y:integer):fleet;
var i,j:integer;
    rf:fleet;
    ff:boolean;

begin
  ff:=false;

  for i:=1 to 4000 do
  begin
    if fleets[i].owner<>-1 then
    begin
      if (x=fleets[i].x) and (y=fleets[i].y) then
      begin
        rf:=fleets[i];
        ff:=true;
      end;
    end;
  end;
  if ff=true then result:=rf else
  begin
    Result.owner:=-1;
    Result.id:=4000;
  end;
end;

procedure GetMinimumDanger(pl,sr,cx,cy:integer; var mx,my:integer);
var i,j,mind,mindx,mindy,efp:integer;

begin
  mind:=fpowlim;
    for i:=(cx-1) to (cx+1) do
    for j:=(cy-1) to (cy+1) do
    begin
      efp:=getfp(form1.getstrongestnearbyfleet(i,j,pl));
      if checkforfleet(i,j).owner<>-1 then efp:=fpowlim;
      if efp<=mind then
      begin
         mind:=efp;
         mindx:=i;
         mindy:=j;
      end;
    end;
  mx:=mindx;
  my:=mindy;
end;

procedure PreloadSprites;
var i,j:integer;
    ftc:string;
    nw:boolean=false;
begin
  //preload sprites
  i:=0; j:=0;
  repeat
    ftc:=ExtractFileDir(Application.ExeName)+'\sprites\'+inttostr(i);
    if (FileExists(ftc+'_r.png')=true)
       and (FileExists(ftc+'_l.png')=true) then
    begin
      spritesr[i]:=TPortableNetworkGraphic.Create;
      spritesr[i].LoadFromFile(ftc+'_r.png');
      spritesl[i]:=TPortableNetworkGraphic.Create;
      spritesl[i].LoadFromFile(ftc+'_l.png');
      bsspritesr[i]:=TPortableNetworkGraphic.Create;
      bsspritesr[i].LoadFromFile(ftc+'_bs_r.png');
      bsspritesl[i]:=TPortableNetworkGraphic.Create;
      bsspritesl[i].LoadFromFile(ftc+'_bs_l.png');
      i:=i+1;
    end
    else nw:=true;
  until nw=true;
  sno:=i;
  //preload backgrounds
  i:=0; j:=0; nw:=false;
  repeat
    ftc:=ExtractFileDir(Application.ExeName)+'\backgrounds\'+inttostr(i)+'.png';
    if FileExists(ftc)=true then
    begin
      backgrounds[i]:=TPortableNetworkGraphic.Create;
      backgrounds[i].LoadFromFile(ftc);
      i:=i+1;
    end
    else nw:=true;
  until nw=true;
  bgno:=i;
  //preload tiles
  i:=0; j:=0; nw:=false;
  repeat
    ftc:=ExtractFileDir(Application.ExeName)+'\sprites\tile_'+inttostr(i)+'.png';
    if FileExists(ftc)=true then
    begin
      vtiles[i]:=TPortableNetworkGraphic.Create;
      vtiles[i].LoadFromFile(ftc);
      i:=i+1;
    end
    else nw:=true;
  until nw=true;
  tlno:=i;

  //preload explosion
  for i:=1 to 7 do
  begin
    ftc:=ExtractFileDir(Application.ExeName)+'\sprites\spl'+inttostr(i)+'.png';
    spritesexpl[i]:=TPortableNetworkGraphic.Create;
    spritesexpl[i].LoadFromFile(ftc);
  end;
end;

{Procedure DropPNG(Source: TPortableNetworkGraphic;
                  OutPNG:TPortableNetworkGraphic; R: TRect);
Var
   i,xmax,ymax: integer;
   Inside: TPortableNetworkGraphic;
Begin
   //Source.CreateAlpha;
   xmax := r.Right - r.Left;
   ymax := r.Bottom - r.Top;
   Inside := TPortableNetworkGraphic.Create;
   BitBlt(Inside.Canvas.Handle,0,0,xmax,ymax,
   Source.Canvas.Handle,R.Left,R.Top,SRCCOPY);
   For i := 0 To ymax - 1 Do
      CopyMemory(Inside.AlphaScanline[i],pByte(dword(Source.AlphaScanline[i + R.Top]) + R.Left),xmax);
   OutPNG.Assign(Inside);
   FreeAndNil(Inside);
End;}

procedure TForm1.Showbriefing(bfn:string;lng:integer);
var toppng:TPortableNetworkGraphic;
    tbfn:string;
begin
  if ballowbriefings=true then
  with form12 do
  begin
    tbfn:=ExtractFileDir(Application.ExeName)+'\briefings\';
    Memo1.Lines.LoadFromFile(tbfn+bfn+'_'+inttostr(lng)+'.txt');
    Image1.Canvas.Pen.Color:=clSkyBlue;
    Image1.Canvas.Brush.Color:=clSkyBlue;
    Image1.Canvas.Rectangle(0,0,Image1.Width,Image1.Height);
    toppng:=TPortableNetworkGraphic.Create;
    toppng.LoadFromFile(tbfn+bfn+'.png');
    Image1.Canvas.CopyRect(rect(0,0,Image1.Width,Image1.Height),toppng.Canvas,
                           rect(0,0,toppng.Width,toppng.Height));
    FreeAndNil(toppng);
    Show;
  end;
end;

procedure TForm1.MenuItem8Click(Sender: TObject);
begin
  //If OpenDialog1.Execute then LoadGame(OpenDialog1.FileName);
end;

procedure TForm1.SaveGame(fn:string);
var k:string;
    i,j,t:integer;
begin
  Form10.Show;
  //cleangamedata;
  with form10 do
  begin
    Memo1.Visible:=false;
    Memo1.Clear;
    Panel1.Caption:='Saving major data';
    ProgressBar1.Min:=0;
    ProgressBar1.Position:=0;

    //data required to load
    Memo1.Lines.Add(inttostr(gw));
    Memo1.Lines.Add(inttostr(gh));
    ProgressBar1.Max:=4000+gw*gh;
    Memo1.Lines.Add(inttostr(turn));
    Memo1.Lines.Add(inttostr(viccond));
    //vc_x,vc_y,vc_id,vc_t
    Memo1.Lines.Add(inttostr(vc_x));
    Memo1.Lines.Add(inttostr(vc_y));
    Memo1.Lines.Add(inttostr(vc_id));
    Memo1.Lines.Add(inttostr(vc_t));
    Memo1.Lines.Add(nmid);
    Memo1.Lines.Add(briefid);
    Memo1.Lines.Add(gbriefid);
    Memo1.Lines.Add(inttostr(cx));
    Memo1.Lines.Add(inttostr(cy));
    Memo1.Lines.Add(inttostr(scl));
    Memo1.Lines.Add(inttostr(acagex));
    Memo1.Lines.Add(inttostr(acagey));
    Memo1.Lines.Add(inttostr(apl));
    Memo1.Lines.Add(inttostr(afleet));
    Memo1.Lines.Add(booltostr(ego));
    Memo1.Lines.Add(booltostr(dsp));
    Memo1.Lines.Add(inttostr(maxpl));
    Memo1.Lines.Add(inttostr(pprice));
    Memo1.Lines.Add(inttostr(minpprice));
    Memo1.Lines.Add(inttostr(maxpprice));
    Memo1.Lines.Add(inttostr(prflux));
    //advanced game data
    Memo1.Lines.Add(floattostr(flcm));
    Memo1.Lines.Add(floattostr(bassp));
    Memo1.Lines.Add(floattostr(bassecm));
    Memo1.Lines.Add(floattostr(basflap));
    Memo1.Lines.Add(floattostr(basflp));
    Memo1.Lines.Add(floattostr(basfsm));
    Memo1.Lines.Add(booltostr(ballowrandom));
    Memo1.Lines.Add(inttostr(sfcm));
    Memo1.Lines.Add(inttostr(sfcp));
    Memo1.Lines.Add(inttostr(fpowlim));
    Memo1.Lines.Add(inttostr(smplim));
    Memo1.Lines.Add(inttostr(bbasedmg));
    Memo1.Lines.Add(inttostr(bbdmg));
    Memo1.Lines.Add(inttostr(bbasehp));
    Memo1.Lines.Add(inttostr(bclpc));
    Memo1.Lines.Add(inttostr(bclmc));
    Memo1.Lines.Add(inttostr(bssmlt));
    Memo1.Lines.Add(inttostr(barc));
    Memo1.Lines.Add(inttostr(btechlim));
    Memo1.Lines.Add(booltostr(bnouselesssectors));
    Memo1.Lines.Add(inttostr(bbslim));
    Memo1.Lines.Add(inttostr(bbscostm));
    Memo1.Lines.Add(inttostr(bbscostp));
    Memo1.Lines.Add(floattostr(bbsmult));
    Memo1.Lines.Add(inttostr(bbssuppcst));
    Memo1.Lines.Add(floattostr(bbshpmult));
    //moneypool and productpool
    for i:=0 to 10 do
    begin
      Memo1.Lines.Add(floattostr(moneypool[i]));
      Memo1.Lines.Add(floattostr(productpool[i]));
    end;
    //tiles
    Panel1.Caption:='Saving sectors';
    for i:=0 to (gw-1) do
    for j:=0 to (gh-1) do
    begin
      Memo1.Lines.Add(inttostr(field[i,j].m));
      Memo1.Lines.Add(inttostr(field[i,j].p));
      Memo1.Lines.Add(inttostr(field[i,j].o));
      Memo1.Lines.Add(inttostr(field[i,j].b));
      Memo1.Lines.Add(inttostr(field[i,j].t));
      ProgressBar1.Position:=ProgressBar1.Position+1;
      Application.ProcessMessages;
    end;
    //fleets
    Panel1.Caption:='Saving fleets';
    for i:=0 to 4000 do
    begin
      Memo1.Lines.Add(inttostr(fleets[i].power));
      Memo1.Lines.Add(inttostr(fleets[i].owner));
      Memo1.Lines.Add(inttostr(fleets[i].ap));
      Memo1.Lines.Add(inttostr(fleets[i].id));
      Memo1.Lines.Add(inttostr(fleets[i].x));
      Memo1.Lines.Add(inttostr(fleets[i].y));
      Memo1.Lines.Add(inttostr(fleets[i].xp));
      Memo1.Lines.Add(inttostr(fleets[i].level));
      Memo1.Lines.Add(floattostr(fleets[i].ab));
      Memo1.Lines.Add(floattostr(fleets[i].db));
      Memo1.Lines.Add(fleets[i].admiral);
      Memo1.Lines.Add(inttostr(fleets[i].battleships));
      ProgressBar1.Position:=ProgressBar1.Position+1;
      Application.ProcessMessages;
    end;
    //players
    Panel1.Caption:='Saving players';
    for i:=0 to 10 do
    begin
      Memo1.Lines.Add(ColorToString(plr[i].color));
      Memo1.Lines.Add(inttostr(plr[i].fleetcost));
      Memo1.Lines.Add(floattostr(plr[i].rfleetcost));
      Memo1.Lines.Add(booltostr(plr[i].human));
      Memo1.Lines.Add(plr[i].name);
      Memo1.Lines.Add(inttostr(plr[i].team));
      Memo1.Lines.Add(inttostr(plr[i].sperc));
      for j:=0 to 11 do Memo1.Lines.Add(inttostr(plr[i].tech[j]));
    end;
    //saving
    Memo1.Lines.SaveToFile(fn);
    Panel1.Caption:='Save complete';
  end;

end;

procedure TForm1.LoadGame(fn:string);
var k:string;
    i,j,t:integer;
begin
  Form10.Show;
  cleangamedata;
  t:=0;
  with form10 do
  begin
    Memo1.Clear;
    Memo1.Lines.LoadFromFile(fn);
    Panel1.Caption:='Loading major data';



    //data required to load
    gw:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    gh:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    ProgressBar1.Min:=0;
    ProgressBar1.Position:=0;
    ProgressBar1.Max:=4000+gw*gh;
    turn:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    viccond:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    //vc_x,vc_y,vc_id,vc_t
    vc_x:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    vc_y:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    vc_id:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    vc_t:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    nmid:=Memo1.Lines[t];
    t:=t+1;
    briefid:=Memo1.Lines[t];
    t:=t+1;
    gbriefid:=Memo1.Lines[t];
    t:=t+1;
    cx:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    cy:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    scl:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    acagex:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    acagey:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    apl:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    afleet:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    ego:=StrToBool(Memo1.Lines[t]);
    t:=t+1;
    dsp:=StrToBool(Memo1.Lines[t]);
    t:=t+1;
    maxpl:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    pprice:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    minpprice:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    maxpprice:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    prflux:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    //advanced game data
    flcm:=StrToFloat(Memo1.Lines[t]);
    t:=t+1;
    bassp:=StrToFloat(Memo1.Lines[t]);
    t:=t+1;
    bassecm:=StrToFloat(Memo1.Lines[t]);
    t:=t+1;
    basflap:=StrToFloat(Memo1.Lines[t]);
    t:=t+1;
    basflp:=StrToFloat(Memo1.Lines[t]);
    t:=t+1;
    basfsm:=StrToFloat(Memo1.Lines[t]);
    t:=t+1;
    ballowrandom:=StrToBool(Memo1.Lines[t]);
    t:=t+1;
    sfcm:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    sfcp:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    fpowlim:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    smplim:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    bbasedmg:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    bbdmg:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    bbasehp:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    bclpc:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    bclmc:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    bssmlt:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    barc:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    btechlim:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    bnouselesssectors:=StrToBool(Memo1.Lines[t]);
    t:=t+1;
    bbslim:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    bbscostm:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    bbscostp:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    bbsmult:=StrToFloat(Memo1.Lines[t]);
    t:=t+1;
    bbssuppcst:=StrToInt(Memo1.Lines[t]);
    t:=t+1;
    bbshpmult:=StrToFloat(Memo1.Lines[t]);
    t:=t+1;
    //moneypool and productpool
    for i:=0 to 10 do
    begin
      moneypool[i]:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      productpool[i]:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
    end;
    //tiles
    Panel1.Caption:='Loading sectors';
    for i:=0 to (gw-1) do
    for j:=0 to (gh-1) do
    begin
      field[i,j].m:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      field[i,j].p:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      field[i,j].o:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      field[i,j].b:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      field[i,j].t:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      ProgressBar1.Position:=ProgressBar1.Position+1;
      Application.ProcessMessages;
    end;
    //fleets
    Panel1.Caption:='Loading fleets';
    for i:=0 to 4000 do
    begin
      fleets[i].power:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      fleets[i].owner:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      fleets[i].ap:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      fleets[i].id:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      fleets[i].x:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      fleets[i].y:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      fleets[i].xp:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      fleets[i].level:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      fleets[i].ab:=StrToFloat(Memo1.Lines[t]);
      t:=t+1;
      fleets[i].db:=StrToFloat(Memo1.Lines[t]);
      t:=t+1;
      fleets[i].admiral:=Memo1.Lines[t];
      t:=t+1;
      fleets[i].battleships:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      ProgressBar1.Position:=ProgressBar1.Position+1;
      Application.ProcessMessages;
    end;
    //players
    Panel1.Caption:='Loading players';
    for i:=0 to 10 do
    begin
      plr[i].color:=StringToColor(Memo1.Lines[t]);
      t:=t+1;
      plr[i].fleetcost:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      plr[i].rfleetcost:=StrToFloat(Memo1.Lines[t]);
      t:=t+1;
      plr[i].human:=StrToBool(Memo1.Lines[t]);
      t:=t+1;
      plr[i].name:=Memo1.Lines[t];
      t:=t+1;
      plr[i].team:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      plr[i].sperc:=StrToInt(Memo1.Lines[t]);
      t:=t+1;
      Form3.InitStatChart;
      Form4.InitChart;
      for j:=0 to 11 do
      begin
        plr[i].tech[j]:=StrToInt(Memo1.Lines[t]);
        t:=t+1;
      end;
    end;
    //saving
    Panel1.Caption:='Load complete';
    mm:=false;
    if briefid<>'' then
    begin
      Form10.Close;
      Showbriefing(briefid,cloc);
    end;
  end;

end;

procedure TForm1.Panel1Click(Sender: TObject);
begin

end;

procedure TForm1.MenuItem4Click(Sender: TObject);
begin
  Form7.Show;
end;

procedure cleanbattledata;
var i:integer;
begin
  for i:=0 to 32000 do
  begin
    with battlefleet[i] do
    begin
      alive:=false;
    end;
    with missiles[i] do
    begin
      alive:=false;
    end;
    with beams[i] do
    begin
      alive:=false;
    end;
    with plasma[i] do
    begin
      alive:=false;
    end;
  end;
end;

procedure cleanpopups;
var i:integer;
begin
  lpop:=0;
  for i:=0 to 100 do
  begin
    pop[i].y:=-1;
    pop[i].active:=false;
    pop[i].ord:=0;
  end;
end;

procedure processpopups;
var i:integer;
begin
  for i:=0 to 100 do
  begin
    pop[i].y:=pop[i].y-(1/(scl/16));
    if pop[i].y<0 then
      pop[i].active:=false;
  end;
end;

procedure addpopup(rqx,rqy:integer; txt:string);
var i:integer=0;
    minid:integer=1000;
    k:boolean=false;
begin
  repeat
    if pop[i].active=false then
    begin
      with pop[i] do
      begin
        text:=txt;
        x:=rqx;
        y:=rqy;
        pop[i].ord:=lpop;
        lpop:=lpop+1;
        active:=true;
        Form1.Log('Adding normal popup');
      end;
      k:=true;
    end;
    i:=i+1;
  until (k=true) or (i>=100);
  {if k=false then
  begin
    for i:=0 to 100 do
    begin
      if pop[i].ord<minid then minid:=pop[i].ord;
    end;
  end;
  if (minid<>1000) and (k=false) then
    with pop[minid] do
    begin
      text:=txt;
      x:=rqx;
      y:=rqy;
      pop[i].ord:=lpop;
      lpop:=lpop+1;
      active:=true;
      Form1.Log('Adding inserted popup');
    end;}
end;

procedure TForm1.SetGameScl(k:integer);
begin
  if mm=false then
  begin
    scl:=scl+k;
    if k<0 then
      if scl<TrackBar1.min then scl:=TrackBar1.Min;
    if k>0 then
      if scl>TrackBar1.max then scl:=TrackBar1.max;
    TrackBar1.Position:=scl;
  end;
end;

procedure TForm1.Log(s:string);
begin
  if Form5.CheckBox1.Checked=true then
  Form5.Memo1.Lines.Add(s);
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin

end;

procedure TForm1.FormResize(Sender: TObject);
begin
  Image1.Picture.Bitmap.Width:=Image1.Width;
  Image1.Picture.Bitmap.Height:=Image1.Height;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var btnid:integer;
begin
  btnid:=checkforbutton(x,y);
  if btnid<>0 then
  begin
    buts[btnid].state:=2;
  end;
  mxp:=X;
  myp:=y;
  if mm=false then
  begin
    ctx:=round(((camx+x)/scl-0.5));
    cty:=round(((camy+y)/scl-0.5));
  end;
end;

procedure TForm1.Image1MouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin

end;

procedure TForm1.Image1MouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  SetGameScl(-1);
end;

procedure TForm1.Image1MouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  SetGameScl(1);
end;

function TForm1.PlayerHasCages(p:integer):boolean;
var ii,jj:integer; nc:integer=0;
begin
  for ii:=0 to (gw-1) do
    for jj:=0 to (gh-1) do
      if field[ii,jj].o=p then nc:=nc+1;
  if nc=0 then result:=false else result:=true;
end;

procedure TForm1.cleangamedata;
var i,j:integer;
begin
  cleanpopups;
  Log('Cleaning game data');
  turn:=0;
  psx:=0;
  viccond:=0;
  briefid:='';
  gbriefid:='';
  nmid:='';
  try freeandnil(priceseries) except end;
  for i:=0 to 10 do
  begin
    try freeandnil(statseries[i]) except end;
//    plrf.
  end;
  for i:=1 to 4000 do
    with fleets[i] do
    begin
      owner:=-1;
      power:=round(basflp);
      ap:=round(basflap);
      id:=i;
      xp:=0;
      db:=1;
      ab:=1;
      level:=1;
      battleships:=0;
    end;
  for i:=0 to (gw-1) do
    for j:=0 to (gh-1) do
      with field[i,j] do
      begin
        p:=0;
        m:=0;
        o:=-1;
        b:=0;
        t:=-1;
      end;
  for i:=1 to 20 do
  begin
    buts[i].x1:=0;
    buts[i].x1:=0;
    buts[i].x1:=0;
    buts[i].x1:=0;
    buts[i].visible:=false;
    buts[i].state:=0;
    buts[i].chm:=4;
    buts[i].text:='';
    buts[i].id:=i;
  end;
end;

procedure TForm1.SpeedButtonClick(Sender: TObject);
begin
  if ig=true then
    if mm=true then mm:=false else mm:=true;
end;

function getmaxf:integer;
var i,r:integer;
begin
  r:=0;
  for i:=1 to 4000 do
  begin
    if fleets[i].owner<>-1 then r:=i;
  end;
  result:=r;
end;



procedure TForm1.startgame(tp:integer; rc:boolean; mp,pp:integer);
var i,xr,yr,j,ii,jj,attmp:integer;
    plrstep:integer;
    ok:boolean;
begin
  Log('Starting a game');
  for i:=0 to (gw-1) do
    for j:=0 to (gh-1) do
      with field[i,j] do
      begin
        if tlno>0 then
        begin
          t:=random(tlno)
        end
        else
        begin
          t:=-1;
          ShowMessage('TlNo not assigned!');
        end;
        if (random(3)=0) or (bnouselesssectors=true) then
        begin
          if random(2)=0 then
          begin
            p:=round(bassp);
            m:=0;
          end
          else
          begin
            m:=round(bassp);
            p:=0;
          end;
        end
        else
        begin
          p:=0;
          m:=0;
        end;
        o:=-1;
      end;
  plrstep:=round((gw+gh)/(tp));
  xr:=random(plrstep);
  yr:=random(plrstep);
  for i:=0 to (tp-1) do
  begin
    if rc=true then
      plr[i].color:=RGBToColor(random(256),random(256),random(256));
    moneypool[i]:=mp;
    productpool[i]:=pp;

    field[xr,yr].m:=round(bassp*2);
    field[xr,yr].p:=0;
    field[xr,yr].o:=i;
    fleets[i+1].x:=xr; fleets[i+1].y:=yr; fleets[i+1].owner:=i; fleets[i+1].ap:=round(basflap);
    fleets[i+1].power:=round(basflp); fleets[i+1].xp:=0; fleets[i+1].level:=1;
    if plr[i].team=1 then fleets[i+1].ab:=1.1 else fleets[i+1].ab:=1;
    if plr[i].team=3 then fleets[i+1].db:=1.1 else fleets[i+1].db:=1;
    plr[i].fleetcost:=sfcm;
    plr[i].rfleetcost:=sfcm;
    plr[i].sperc:=100;
    plr[i].tech[0]:=1;
    plr[i].tech[1]:=1;
    plr[i].tech[2]:=1;
    plr[i].tech[3]:=1;
    plr[i].tech[4]:=1;
    maxpl:=tp;
    pprice:=10;

    Form3.InitStatChart;
    Form4.InitChart;
    ok:=false;
    attmp:=0;
    repeat
      xr:=xr+1;
      //yr:=yr+random(plrstep)+random(2)+1;
      if xr>=(gw-1) then
      begin
        xr:=0;
        yr:=yr+1;
        //yr:=yr+(plrstep)+random(2)+2;
      end;
      if yr>=(gh-1) then yr:=0;
      ok:=false;
      if field[xr,yr].o=-1 then
      for ii:=(xr-3) to (xr+3) do
      for jj:=(yr-3) to (yr+3) do
      begin
        if (ii>=0) and (ii<=(gw-1)) and (jj>=0) and (jj<=(gh-1)) then
          if field[ii,jj].o<>-1 then ok:=false;
      end;
      if ok=false then attmp:=attmp+1;
    until (ok=true) or (attmp>(gw*gh*10000));
    //if attmp>=(gw*gh*1000) then ShowMessage('Can`t position!');
  end;
end;

procedure TForm1.ResearchTech(pl,tch:integer);
begin
  if (moneypool[pl]>=(sqr(plr[pl].tech[tch])*barc)) and (plr[pl].tech[tch]<btechlim) then
  begin
    moneypool[pl]:=moneypool[pl]-(sqr(plr[pl].tech[tch])*barc);
    plr[pl].tech[tch]:=plr[pl].tech[tch]+1;
    if tch=4 then
    begin
      plr[pl].fleetcost:=round(plr[pl].fleetcost/2);
    end;
  end
  else
  begin
    if plr[pl].human=true then
    begin
      if (moneypool[pl]<(sqr(plr[pl].tech[tch])*barc)) then
         MessageDlg(strarr[125],mtError,[mbOK],0);
      if (plr[pl].tech[tch]>=btechlim) then
         MessageDlg(strarr[126],mtError,[mbOK],0);
    end;
  end;
end;

procedure TForm1.Image1DblClick(Sender: TObject);
begin

end;

procedure TForm1.MenuItem5Click(Sender: TObject);
begin
  if SaveDialog1.Execute then SaveGame(SaveDialog1.FileName);
end;

procedure TForm1.MenuItem6Click(Sender: TObject);
begin
  If OpenDialog1.Execute then LoadGame(OpenDialog1.FileName);
end;

procedure TForm1.MenuItem7Click(Sender: TObject);
begin
  Form11.Show;
end;

procedure TForm1.MenuItem2Click(Sender: TObject);
begin
  plr[1].human:=true;
  mm:=false;
  halt;
  //Form1.Close;
end;

function calcplayerprofit(pl:integer):integer;
var i,j:integer;
    r:integer=0;
begin
  for i:=0 to (gw-1) do
  for j:=0 to (gh-1) do
  begin
    if field[i,j].o=pl then
    begin
      r:=r+field[i,j].m;
      if field[i,j].b=2 then r:=round(r*1.1);
    end;
  end;
  result:=r;
end;



function calcplayerproduct(pl:integer):integer;
var i,j:integer;
    r:integer=0;
begin
  for i:=0 to (gw-1) do
  for j:=0 to (gh-1) do
  begin
    if field[i,j].o=pl then
    begin
      if plr[pl].team=2 then
        r:=round(r+field[i,j].p*1.1)
      else
        r:=r+field[i,j].p;
      if field[i,j].b=3 then r:=round(r*1.1);
    end;
  end;
  r:=round(r+(r*0.1*plr[pl].tech[3]));
  r:=round(r*(plr[pl].sperc/100));
  result:=r;
end;


function calcplayerexp(pl:integer):integer;
var i,j:integer;
    r:integer=0;
begin
  for i:=1 to 4000 do
  begin
    if fleets[i].owner=pl then
    begin
      r:=r+round(fleets[i].power*basfsm);
      r:=r+round(fleets[i].battleships*bbssuppcst*bbsmult);
    end;
  end;
  r:=r+round(calcplayerproduct(apl)*(plr[apl].sperc/100)*bbprodsc);
  result:=r;
end;

procedure TForm1.constructbuilding(bcx,bcy,blid,pl:integer);
begin
  //fp:=field[bcx,bcy].m+field[bcx,bcy].m;
  //constructs a building in selected cage
  if (moneypool[pl]>=round(barc/5)) and (field[bcx,bcy].o=pl) then
  begin
    field[bcx,bcy].b:=blid;
    moneypool[pl]:=moneypool[pl]-round(barc/5);
    if blid=1 then
    begin
      plr[pl].fleetcost:=round(plr[pl].fleetcost*0.95);
    end;
  end;
end;

procedure TForm1.deconstructbuilding(bcx,bcy,blid,pl:integer);
begin
  //fp:=field[bcx,bcy].m+field[bcx,bcy].m;
  //constructs a building in selected cage
  if (moneypool[pl]>=round(barc/5)) and (field[bcx,bcy].o=pl) then
  begin
    if field[bcx,bcy].b=1 then
    begin
      plr[pl].fleetcost:=round(plr[pl].fleetcost*1.05);
    end;
    field[bcx,bcy].b:=0;
    moneypool[pl]:=moneypool[pl]-round(barc/5);
  end;
end;

procedure TForm1.DrawCombat(cnvf:TCanvas;xf,yf:integer;ww,wh:integer);
var i:integer;
    rbmp:TBitmap;
    wf,hf:integer;
    //iw,ih:integer;
    bfhpk:integer;
    lw:integer;
    csw,csh:integer;
    tpngs:TPortableNetworkGraphic;
    rsid,cv:integer;

begin
  rbmp:=TBitmap.Create;
  rbmp.Width:=bfw;
  rbmp.Height:=bfh;
  with rbmp.canvas do
  begin
    Pen.Color:=clSkyBlue;
    Brush.Color:=clBlack;
    Brush.Style:=bsSolid;
    Pen.Width:=1;
    bfscl:=(ww/bfw);
    wf:=round(bfw*bfscl);
    hf:=round(bfh*bfscl);
    Rectangle(1,1,wf,hf);
    {if bgno>0 then
    begin
      CopyRect(rect(2,2,wf-1,hf-1),backgrounds[bbgn].Canvas,
               rect(0,0,backgrounds[bbgn].Width,backgrounds[bbgn].height));
    end;}
    if Form5.CheckBox2.Checked=true then
      Form5.Memo1.Clear;
    for i:=0 to (bp1+bp2-1) do
    begin
      Pen.Color:=clBlack;
      Brush.Color:=clBlack;
      Pen.Width:=1;
      if Form5.CheckBox2.Checked=true then
        Form5.Memo1.Lines.Add(inttostr(i)+') '+inttostr(missiles[i].x1)+
                              ','+IntToStr(missiles[i].y1)+' ('+
                              inttostr(missiles[i].tid)+': '+
                              inttostr(missiles[i].tx)+','+
                              inttostr(missiles[i].ty)+')');
      if battlefleet[i].alive=true then
      begin
       csw:=30; csh:=6;
        Pen.Color:=clBlack; Brush.Color:=battlefleet[i].color; Brush.Style:=bsSolid;
        if sno=0 then
        Ellipse(round((battlefleet[i].x1-15)*bfscl),
                round((battlefleet[i].y1-3)*bfscl),
                round((battlefleet[i].x1+15)*bfscl),
                round((battlefleet[i].y1+3)*bfscl));
        cv:=0;
        if sno>0 then
        begin
          if i<bp1 then rsid:=cbt1 else rsid:=cbt2;
          if battlefleet[i].orient=1 then
          begin
            csw:=spritesr[plr[rsid].team].Width;
            csh:=spritesr[plr[rsid].team].Height;
            {tpngs:=TPortableNetworkGraphic.Create;
            tpngs.Width:=csw;
            tpngs.Height:=csh;
            tpngs.Canvas.CopyRect(rect(0,0,csw,csh),spritesr[plr[rsid].team].Canvas,
                                  rect(0,0,csw,csh));}
            cv:=1;
          end
          else
          begin
            csw:=spritesl[plr[rsid].team].Width;
            csh:=spritesl[plr[rsid].team].Height;
            //tpngs:=TPortableNetworkGraphic.Create;
            //tpngs.Width:=csw;
            //tpngs.Height:=csh;
            {tpngs.Canvas.CopyRect(rect(0,0,csw,csh),spritesl[plr[rsid].team].Canvas,
                                  rect(0,0,csw,csh));}
            cv:=2;
          end;
          if cv=1 then
          CopyRect(rect(round((battlefleet[i].x1-csw/2)*bfscl),
                        round((battlefleet[i].y1-csh/2)*bfscl),
                        round((battlefleet[i].x1+csw/2)*bfscl),
                        round((battlefleet[i].y1+csh/2)*bfscl)),
                   spritesr[plr[rsid].team].Canvas,rect(0,0,csw,csh));
          if cv=2 then
          CopyRect(rect(round((battlefleet[i].x1-csw/2)*bfscl),
                        round((battlefleet[i].y1-csh/2)*bfscl),
                        round((battlefleet[i].x1+csw/2)*bfscl),
                        round((battlefleet[i].y1+csh/2)*bfscl)),
                   spritesl[plr[rsid].team].Canvas,rect(0,0,csw,csh));
          //FreeAndNil(tpngs);
        end;
        Pen.Color:=clLime;
        Brush.Color:=clBlack;
        Brush.Style:=bsSolid;
        Rectangle(round((battlefleet[i].x1-csw/2)*bfscl),
                  round((battlefleet[i].y1-((csh/2)+5))*bfscl),
                  round((battlefleet[i].x1+csw/2)*bfscl),
                  round((battlefleet[i].y1-((csh/2)+11))*bfscl));
        Brush.Color:=clLime;
        bfhpk:=round(csw*battlefleet[i].hp/bbasehp);
        Rectangle(round((battlefleet[i].x1-csw/2)*bfscl),
                  round((battlefleet[i].y1-((csh/2)+5))*bfscl),
                  round((battlefleet[i].x1+(bfhpk-csw/2))*bfscl),
                  round((battlefleet[i].y1-((csh/2)+11))*bfscl));
      end;
      Pen.Width:=round(2*bfscl);
      if Pen.Width=0 then Pen.Width:=1;
      if beams[i].alive=true then
      begin
        Pen.Color:=beams[i].color;
        MoveTo(round(beams[i].x1*bfscl),round(beams[i].y1*bfscl));
        LineTo(round(beams[i].tx*bfscl),round(beams[i].ty*bfscl));
      end;
      Pen.Color:=clAqua;
      Brush.Color:=clWhite;
      Pen.Width:=1;
      if missiles[i].alive=true then
      begin
        Brush.Style:=bsSolid;
        Pen.Color:=clAqua;
        Brush.Color:=clWhite;
        Ellipse(round((missiles[i].x1-3)*bfscl),round((missiles[i].y1-3)*bfscl),
                round((missiles[i].x1+3)*bfscl),round((missiles[i].y1+3)*bfscl));
        //MoveTo(missiles[i].x1,missiles[i].y1);
        //Pen.Width:=1;
        //Pen.Color:=clLime;
        //LineTo(missiles[i].x1,missiles[i].y1);
        Brush.Style:=bsClear;
        Rectangle(round((battlefleet[missiles[i].tid].x1-round(missiles[i].spd))*bfscl),
                  round((battlefleet[missiles[i].tid].y1-round(missiles[i].spd))*bfscl),
                  round((battlefleet[missiles[i].tid].x1+round(missiles[i].spd))*bfscl),
                  round((battlefleet[missiles[i].tid].y1+round(missiles[i].spd))*bfscl));
        //TextOut(missiles[i].x1+2,missiles[i].y1-scl,inttostr(missiles[i].x1)+
        //        ','+IntToStr(missiles[i].y1));
      end;
    end;
    cnvf.CopyRect(rect(xf,yf,wf+xf,hf+yf),rbmp.Canvas,rect(0,0,wf,hf));
    FreeAndNil(rbmp);
    Application.ProcessMessages;
  end;
end;

//---------------MAIN REDRAWING PROCEDURE---------------//

procedure TForm1.Redraw;
var i,j:integer;
    fbmp,rbmp:TBitmap;
    iw,ih,lw,cpw,cph:integer;
    csw,csh:integer;
    bfhpk:integer;
    rsid,cv:integer;
    tpngs:TPortableNetworkGraphic;
    wf,hf:integer;
    xf,yf:integer;
    ww,wh:integer;
    //additional tech variables
    cbgw,cbgh,bgwtc,bghtc:integer;
    bgtop,bgleft,bgbottom,bgright:integer;
    intfl:fleet;
    ny1,ny2,cny,pws:integer;
    curstr:string;
    sntlcx,sntlcy:integer; // ship info top left corner coords
begin
  //---1. Draw battlefield---
  globalbmp:=TBitmap.Create;
  globalbmp.Width:=gw*scl;
  globalbmp.Height:=gh*scl;
  fbmp:=TBitmap.Create;
  iw:=Image1.Width;
  ih:=Image1.Height;
  fbmp.Width:=iw;
  fbmp.Height:=ih;
  if cm=false then
  with globalbmp.Canvas do
  begin
    //sectors
    Pen.Color:=plr[apl].color;
    Pen.Width:=1;
    Brush.Style:=bsSolid;
    Rectangle(0,0,width,height);
    for i:=0 to (gw-1) do
    for j:=0 to (gh-1) do
    begin
      Brush.Style:=bsSolid;
      Brush.Color:=clBlack;
      Pen.Color:=clGray;
      pen.Width:=1;
      if (acagex=i) and (acagey=j) then
        pen.Width:=pen.Width+2;
      if field[i,j].b=4 then Pen.Width:=pen.Width+2;

      //here we copyrect a tile

      if (field[i,j].t<>-1) and (field[i,j].t<tlno) then
      begin
        CopyRect(
                 Rect(i*scl+1,j*scl+1,i*scl+scl,j*scl+scl),
                 vtiles[field[i,j].t].Canvas,
                 Rect(0,0,vtiles[field[i,j].t].Width,vtiles[field[i,j].t].Height)
                );
      end;

      //end of tile placement
      if (field[i,j].t<>-1) and (field[i,j].t<tlno) then
      begin
        Brush.Style:=bsClear;
      end
      else Brush.Style:=bsSolid;
      if (CheckBox6.Checked=true) or ((i=acagex) and (j=acagey)) then
        Rectangle(i*scl,j*scl,i*scl+scl+1,j*scl+scl+1);
      if (field[i,j].o>=0) and (field[i,j].o<=(maxpl-1)) then
      begin
        Brush.Style:=bsBDiagonal;
        if ego=false then
        begin
          pen.Color:=plr[field[i,j].o].color;
          Brush.Color:=plr[field[i,j].o].color;
        end
        else
        begin
          if field[i,j].o=apl then
          begin
            pen.Color:=clLime;
            Brush.Color:=clLime;
          end else
          begin
            pen.Color:=clRed;
            Brush.Color:=clRed;
          end
        end;
      end;
      if (CheckBox6.Checked=true) or ((i=acagex) and (j=acagey)) or (field[i,j].o<>-1) or (field[i,j].b=4) then
        Rectangle(i*scl,j*scl,i*scl+scl+1,j*scl+scl+1);
      if dsp=true then
      begin
        Font.Name:='Arial Narrow';
        Font.Size:=scl div 2;
        if (field[i,j].m<>0) then
        begin
          Brush.Style:=bsClear;
          Font.Color:=clYellow;
          curstr:=inttostr(field[i,j].m);
          if field[i,j].b=2 then curstr:=curstr+'+';
          TextOut(i*scl+2,j*scl+2,curstr);
        end;
        if (field[i,j].p<>0) then
        begin
          Brush.Style:=bsClear;
          Font.Color:=clLime;
          curstr:=inttostr(field[i,j].p);
          if field[i,j].b=2 then curstr:=curstr+'+';
          TextOut(i*scl+2,j*scl+2,curstr);
        end;
      end;
    end;
    //fleets
    if (cmkx<>0) or (cmky<>0) then
    begin
      pen.Color:=plr[checkforfleet(ctx,cty).owner].color;
      pen.Width:=2;
      Brush.Color:=pen.Color;
      MoveTo(round(ctx*scl+(scl/2)),round(cty*scl+(scl/2)));
      LineTo(round((ctx+cmkx)*scl+(scl/2)),round((cty+cmky)*scl+(scl/2)));
      Ellipse(round((ctx+cmkx)*scl+(scl/2))-round(scl/4),
              round((cty+cmky)*scl+(scl/2))-round(scl/4),
              round((ctx+cmkx)*scl+(scl/2))+round(scl/4),
              round((cty+cmky)*scl+(scl/2))+round(scl/4));
      pen.Width:=1;
    end;
    for i:=1 to 4000 do
    begin
      if fleets[i].owner<>-1 then
      begin
        pen.Color:=plr[fleets[i].owner].color;
        if afleet=i then
        begin
          pen.Color:=clWhite;
        end;
        Brush.Style:=bsSolid;
        if ego=false then
          Brush.Color:=plr[fleets[i].owner].color
        else
        begin
          if fleets[i].owner<>apl then Brush.Color:=clRed
          else Brush.Color:=clLime;
        end;
        Brush.Style:=bsSolid;
        Ellipse(fleets[i].x*scl+2,fleets[i].y*scl+2,fleets[i].x*scl+scl-2,fleets[i].y*scl+scl-2);
        if fleets[i].battleships=0 then
        CopyRect(rect(fleets[i].x*scl+2,fleets[i].y*scl+2,fleets[i].x*scl+scl-2,fleets[i].y*scl+scl-2),
                 spritesl[plr[fleets[i].owner].team].Canvas,
                 rect(0,0,spritesl[plr[fleets[i].owner].team].Width,
                      spritesl[plr[fleets[i].owner].team].Height));
        if fleets[i].battleships>0 then
        CopyRect(rect(fleets[i].x*scl+2,fleets[i].y*scl+2,fleets[i].x*scl+scl-2,fleets[i].y*scl+scl-2),
                 bsspritesl[plr[fleets[i].owner].team].Canvas,
                 rect(0,0,bsspritesl[plr[fleets[i].owner].team].Width,
                      bsspritesl[plr[fleets[i].owner].team].Height));
        Font.Name:='Arial Narrow';
        Font.Size:=scl div 4;
        if plr[fleets[i].owner].color<>clWhite then
          Font.Color:=clWhite
        else
          Font.Color:=clBlack;
        Brush.Style:=bsClear;
        TextOut(fleets[i].x*scl+4,fleets[i].y*scl+4,inttostr(round(fleets[i].power+(fleets[i].battleships*bbshpmult))));
        //ap indicator
        Pen.Color:=clWhite;
        Pen.Style:=psSolid;
        Brush.Style:=bsSolid;
        if fleets[i].ap>0 then
        begin
          Pen.Color:=clLime;
          Brush.Color:=clLime;
        end
        else
        begin
          Pen.Color:=clRed;
          Brush.Color:=clRed;
        end;
        Ellipse(fleets[i].x*scl+scl-6,fleets[i].y*scl,fleets[i].x*scl+scl,fleets[i].y*scl+6);
        //intruder indicator
        {if (afleet=i) then
        begin
          intfl:=GetNearestIntruder(fleets[i],round((gw)));
          if (intfl.owner<>-1) then
          begin
            //Pen.Color:=clWhite;
            Pen.Style:=pssOLID;
            Pen.Width:=2;
            Pen.Color:=clRed;
            moveto(fleets[i].x*scl,fleets[i].y*scl);
            LineTo(intfl.x*scl,intfl.y*scl);
          end;
        end;}
      end;
    end;
    {for i:=1 to 4000 do
    begin
      if fleets[i].owner<>-1 then
      begin

      end;
    end;   }
  end;
  //---2. UI panel---
  with fbmp.Canvas do
  begin

    CopyRect(rect(0,0,iw,ih),globalbmp.Canvas,rect(camx,camy,camx+iw,camy+ih));
    Pen.Color:=plr[apl].color;
    Pen.Width:=3;
    Brush.Color:=clSkyBlue;
    Rectangle(iw-200,0,iw,ih);
    Font.Name:='Courier New';
    Font.Size:=10;
    Font.Color:=clBlack;
    TextOut(iw-195,ih-20,inttostr(cx)+','+inttostr(cy));
    if plr[apl].name<>'' then
      TextOut(iw-195,10,plr[apl].name + ' ('+inttostr(apl)+')')
    else
      TextOut(iw-195,10,strarr[27]+': '+inttostr(apl));
    //cage info panel
    ny1:=25; ny2:=145; cny:=0;
    Rectangle(iw-195,ny1,iw-5,ny2);
    cny:=cny+5;
    TextOut(iw-190,ny1+cny,strarr[31]);
    cny:=cny+15;
    if field[acagex,acagey].o=-1 then
      TextOut(iw-190,ny1+cny,'-'+strarr[32]+': -')
    else
      TextOut(iw-190,ny1+cny,'-'+strarr[32]+': '+inttostr(field[acagex,acagey].o));
    cny:=cny+20;
    TextOut(iw-190,ny1+cny,'-'+strarr[33]+': '+inttostr(field[acagex,acagey].m));
    cny:=cny+20;
    TextOut(iw-190,ny1+cny,'-'+strarr[34]+': '+inttostr(field[acagex,acagey].p));
    cny:=cny+20;
    with buts[1] do
    begin
      y1:=ny1+cny;
      cny:=cny+15;
      y2:=ny1+cny;
      x1:=iw-190;
      x2:=iw-10;
      visible:=true;
      text:=SpeedButton3.Caption;
      cb:=false;
      //state:=0;
    end;
    with buts[2] do
    begin
      cny:=cny+5;
      y1:=ny1+cny; cny:=cny+15;
      y2:=ny1+cny;
      x1:=iw-190;
      x2:=iw-10;
      visible:=true;
      text:=SpeedButton2.Caption;
      cb:=false;
      //state:=0;
    end;
    //fleet info panel
    ny1:=ny2+5; ny2:=ny1+160; cny:=0;
    Rectangle(iw-195,ny1,iw-5,ny2);
    if fleets[afleet].owner<>-1 then
    begin
      MoveTo(iw-195,ny1);
      LineTo(iw-195-round((iw-195-(camx+fleets[afleet].x*scl))/2),ny1);
      MoveTo(iw-195-round((iw-195-(camx+fleets[afleet].x*scl))/2),ny1);
      LineTo((fleets[afleet].x*scl+scl)-camx,(fleets[afleet].y*scl)-camy);
    end;
    cny:=ny1+5;
    TextOut(iw-190,cny,strarr[35]+' ('+strarr[36]+' '+inttostr(fleets[afleet].level)+')');
    cny:=cny+15;
    if fleets[afleet].owner=-1 then
      TextOut(iw-190,cny,'-'+strarr[32]+': -')
    else
      TextOut(iw-190,cny,'-'+strarr[32]+': '+inttostr(fleets[afleet].owner));
    cny:=cny+15;

    TextOut(iw-190,cny,'-'+strarr[38]+
            ': '+inttostr(round(fleets[afleet].power+(fleets[afleet].battleships*bbshpmult)))+
            ' ('+inttostr(fleets[afleet].power)+'/'+inttostr(fleets[afleet].battleships)+')');

    cny:=cny+15;
    TextOut(iw-190,cny,
              '  ('+strarr[39]+': '+floattostr((fleets[afleet].ab-1)*100)+
              '%; '+strarr[40]+': '+floattostr((fleets[afleet].db-1)*100)+'%)');
    cny:=cny+15;
    TextOut(iw-190,cny,'-'+strarr[41]+': '+inttostr(fleets[afleet].ap));
    Brush.Color:=clBlack;
    Pen.Color:=plr[apl].color;
    cny:=cny+15;
    Rectangle(iw-190,cny,iw-10,cny+15);
    Brush.Color:=clBlue;
    Rectangle(iw-190,cny,
             (iw-190)+round(((abs((iw-190)-(iw-10)))*(fleets[afleet].xp/(power(10,fleets[afleet].level))))),
             cny+15);
    Brush.Style:=bsClear ;
    Font.Size:=8;
    Font.Color:=clWhite;
    TextOut(iw-188,cny+1,inttostr(fleets[afleet].xp)+'/'+inttostr(round(power(10,fleets[afleet].level))));
    Font.Size:=10;
    Font.Color:=clBlack;
    Brush.Style:=bsSolid;
    Brush.Color:=clSkyBlue;
    cny:=cny+20;
    with buts[3] do
    begin
      y1:=cny;
      cny:=cny+15;
      y2:=cny;
      x1:=iw-190;
      x2:=iw-10;
      visible:=true;
      text:=SpeedButton1.Caption;
      cb:=false;
      //state:=0;
    end;
    with buts[4] do
    begin
      cny:=cny+5;
      y1:=cny; cny:=cny+15;
      y2:=cny;
      x1:=iw-190;
      x2:=iw-10;
      visible:=true;
      text:=SpeedButton6.Caption;
      cb:=false;
      //state:=0;
    end;
    with buts[15] do
    begin
      cny:=cny+5;
      y1:=cny; cny:=cny+15;
      y2:=cny;
      x1:=iw-190;
      x2:=iw-10;
      visible:=true;
      text:=SpeedButton17.Caption;
      cb:=false;
      //state:=0;
    end;

    //economy panel
    ny1:=ny2+5; ny2:=ny1+105; cny:=ny1;
    Rectangle(iw-195,cny,iw-5,ny2);
    cny:=cny+5;
    TextOut(iw-190,cny,strarr[5]);
    cny:=cny+15;
    TextOut(iw-190,cny,'-'+Label1.Caption); //moneypool
    cny:=cny+15;
    Font.Size:=Font.Size-2;
    TextOut(iw-185,cny,'* '+Label2.Caption); //income
    cny:=cny+15;
    TextOut(iw-185,cny,'* '+Label3.Caption); //exp
    cny:=cny+15;
    Font.Size:=Font.Size+2;
    TextOut(iw-190,cny,'-'+strarr[9]+': '+inttostr(productpool[apl])); //prod
    cny:=cny+15;
    Font.Size:=Font.Size-2;
    TextOut(iw-185,cny,'* '+strarr[150]+' '+inttostr(calcplayerproduct(apl))+' ('+inttostr(plr[apl].sperc)+'%)'); //prod
    cny:=cny+15;
    Font.Size:=Font.Size+2;

    //controls panel

    with buts[5] do //tech
    begin
      cny:=cny+15;
      y1:=cny; cny:=cny+15;
      y2:=cny;
      x1:=iw-195;
      x2:=iw-5;
      visible:=true;
      text:=SpeedButton16.Caption;
      cb:=false;
      //state:=0;
    end;
    with buts[6] do //trade
    begin
      cny:=cny+5;
      y1:=cny; cny:=cny+15;
      y2:=cny;
      x1:=iw-195;
      x2:=iw-5;
      visible:=true;
      text:=strarr[151];
      cb:=false;
      //state:=0;
    end;
    with buts[7] do //stats
    begin
      cny:=cny+5;
      y1:=cny; cny:=cny+15;
      y2:=cny;
      x1:=iw-195;
      x2:=iw-5;
      visible:=true;
      text:=SpeedButton5.Caption;
      cb:=false;
      //state:=0;
    end;

    //CHECKBOXES
    with buts[8] do
    begin
      cny:=cny+5;
      y1:=cny; cny:=cny+15;
      y2:=cny;
      x1:=iw-195;
      x2:=iw-5;
      visible:=true;
      text:=CheckBox1.Caption;
      cb:=true;
      cbc:=CheckBox1.Checked;
      //state:=0;
    end;
    with buts[9] do
    begin
      cny:=cny+5;
      y1:=cny; cny:=cny+15;
      y2:=cny;
      x1:=iw-195;
      x2:=iw-5;
      visible:=true;
      text:=CheckBox2.Caption;
      cb:=true;
      cbc:=CheckBox2.Checked;
      //state:=0;
    end;
    with buts[10] do
    begin
      cny:=cny+5;
      y1:=cny; cny:=cny+15;
      y2:=cny;
      x1:=iw-195;
      x2:=iw-5;
      visible:=true;
      text:=CheckBox3.Caption;
      cb:=true;
      cbc:=CheckBox3.Checked;
      //state:=0;
    end;
    with buts[11] do
    begin
      cny:=cny+5;
      y1:=cny; cny:=cny+15;
      y2:=cny;
      x1:=iw-195;
      x2:=iw-5;
      visible:=true;
      text:=CheckBox4.Caption;
      cb:=true;
      cbc:=CheckBox4.Checked;
      //state:=0;
    end;
    with buts[12] do
    begin
      cny:=cny+5;
      y1:=cny; cny:=cny+15;
      y2:=cny;
      x1:=iw-195;
      x2:=iw-5;
      visible:=true;
      text:=CheckBox5.Caption;
      cb:=true;
      cbc:=CheckBox5.Checked;
      //state:=0;
    end;
    with buts[16] do
    begin
      cny:=cny+5;
      y1:=cny; cny:=cny+15;
      y2:=cny;
      x1:=iw-195;
      x2:=iw-5;
      visible:=true;
      text:=CheckBox6.Caption;
      cb:=true;
      cbc:=CheckBox6.Checked;
      //state:=0;
    end;
    with buts[14] do
    begin
      cny:=cny+5;
      y1:=cny; cny:=cny+20;
      y2:=cny;
      x1:=iw-195;
      x2:=iw-5;
      visible:=true;
      text:=SpeedButton4.Caption;
      cb:=false;
      //state:=0;
    end;
    with buts[13] do
    begin
      y1:=5;
      y2:=23;
      x1:=iw-90;
      x2:=iw-5;
      visible:=true;
      text:=strarr[137];
      cb:=false;
      //state:=0;
    end;

    {Pen.Color:=clBlack;
    Pen.Width:=1;
    Brush.Color:=clWhite;
    Font.Size:=7;
    Rectangle(iw-195,210,iw-5,225);
    TextOut(iw-190,212,strarr[42]);
    Rectangle(iw-195,230,iw-5,245);
    TextOut(iw-190,232,strarr[43]);
    Rectangle(iw-195,250,iw-5,265);
    TextOut(iw-190,252,strarr[44]);
    Rectangle(iw-195,270,iw-5,285);
    TextOut(iw-190,272,strarr[45]);
    Rectangle(iw-195,290,iw-5,305);
    TextOut(iw-190,292,strarr[46]);}


    //buttons
    pws:=Pen.Width;
    for i:=1 to 20 do
    begin
      Pen.Width:=1;
      if buts[i].visible=true then
      begin
        Brush.Style:=bsSolid;
        Pen.Style:=psSolid;
        if buts[i].state=0 then
        begin
          Brush.Color:=clSkyBlue;
          Pen.Color:=clBlack;
          Font.Name:='Courier New';
          Font.Color:=clBlack;
          Font.Style:=[fsBold];
          Font.Size:=abs(round((buts[i].y1-buts[i].y2)/2));
        end;
        if buts[i].state=1 then
        begin
          Brush.Color:=clYellow;
          Pen.Color:=clBlack;
          Font.Name:='Courier New';
          Font.Color:=clBlack;
          Font.Style:=[fsBold];
          Font.Size:=abs(round((buts[i].y1-buts[i].y2)/2));
        end;
        if buts[i].state=2 then
        begin
          Brush.Color:=clRed;
          Pen.Color:=clWhite;
          Font.Name:='Courier New';
          Font.Color:=clWhite;
          Font.Style:=[];
          Font.Size:=abs(round((buts[i].y1-buts[i].y2)/2));
        end;
        RoundRect(buts[i].x1,buts[i].y1,buts[i].x2,buts[i].y2,buts[i].chm,buts[i].chm);
        if buts[i].cb=false then
        begin
          Brush.Style:=bsClear;
          TextOut(buts[i].x1+buts[i].chm,buts[i].y1+1,buts[i].text);
        end;
        if buts[i].cb=true then
        begin
          Brush.Style:=bsClear;
          TextOut(buts[i].x1+buts[i].chm+(abs((buts[i].y1+1)-(buts[i].y2-1)))+1,
                  buts[i].y1+1,buts[i].text);
          Brush.Style:=bsSolid;
          Brush.Color:=clWhite;
          Rectangle(buts[i].x1+buts[i].chm,buts[i].y1+1,
                    buts[i].x1+buts[i].chm+(abs((buts[i].y1+1)-(buts[i].y2-1))),
                    buts[i].y2-1);
          if buts[i].cbc=true then
          begin
            Brush.Style:=bsSolid;
            Brush.Color:=clBlack;
            Ellipse(buts[i].x1+buts[i].chm+1,buts[i].y1+2,
                      buts[i].x1+buts[i].chm+(abs((buts[i].y1+2)-(buts[i].y2-2))),
                      buts[i].y2-2);
          end;
        end;
        Font.Style:=[];
        Font.Color:=clBlack;
        Brush.Style:=bsSolid;
      end;
    end;
    Pen.Width:=pws;

    //COMBAT DISPLAY

    if cm=true then
    begin
      //DrawCombat(fbmp.canvas,5,5,iw-200-10,round(((iw-200-10)*9)/16));
      xf:=5;
      yf:=5;
      ww:=iw-xf-10;
      wh:=round(((iw-yf-10)*9)/16);
      rbmp:=TBitmap.Create;
      rbmp.Width:=bfw;
      rbmp.Height:=bfh;
      with rbmp.canvas do
      begin
        Pen.Color:=plr[apl].color;
        Brush.Color:=clBlack;
        Brush.Style:=bsSolid;
        Pen.Width:=1;
        bfscl:=(ww/bfw);
        wf:=round(bfw*bfscl);
        hf:=round(bfh*bfscl);
        Rectangle(1,1,wf,hf);
        if bgno>0 then
        begin
          cbgw:=backgrounds[bbgn].Width;
          cbgh:=backgrounds[bbgn].Height;
          if (cbgw-(wf-2))>0 then
          begin
            bgwtc:=wf-2;
            bghtc:=hf-2;
            bgleft  :=round((cbgw/2)-((wf-2)/2));
            bgtop   :=round((cbgh/2)-((hf-2)/2));
            bgright :=round((cbgw/2)+((wf-2)/2));
            bgbottom:=round((cbgh/2)+((hf-2)/2));
          end
          else
          begin
            bgwtc:=cbgw;
            bghtc:=cbgh;
            bgtop:=0;
            bgleft:=0;
            bgbottom:=cbgh;
            bgright:=cbgw;
          end;
          CopyRect(rect(2,2,wf-1,hf-1),backgrounds[bbgn].Canvas,
                   rect(bgleft,bgtop,bgright,bgbottom));
        end;
        if Form5.CheckBox2.Checked=true then
           Form5.Memo1.Clear;
       for i:=0 to (bp1+bp2-1) do
       begin
          Pen.Color:=clBlack;
          Brush.Color:=clBlack;
          Pen.Width:=1;
          if Form5.CheckBox2.Checked=true then
            Form5.Memo1.Lines.Add(inttostr(i)+') '+inttostr(missiles[i].x1)+
                                  ','+IntToStr(missiles[i].y1)+' ('+
                                  inttostr(missiles[i].tid)+': '+
                                  inttostr(missiles[i].tx)+','+
                                  inttostr(missiles[i].ty)+')');
          if (battlefleet[i].alive=true) or (battlefleet[i].animframe>0) then
          begin
            csw:=30; csh:=6;
            Pen.Color:=clBlack; Brush.Color:=battlefleet[i].color; Brush.Style:=bsSolid;
            if sno=0 then
            Ellipse(round((battlefleet[i].x1-15)*bfscl),
                    round((battlefleet[i].y1-3)*bfscl),
                    round((battlefleet[i].x1+15)*bfscl),
                    round((battlefleet[i].y1+3)*bfscl));
            cv:=0;
            if sno>0 then
            begin
              if i<bp1 then rsid:=cbt1 else rsid:=cbt2;
              if battlefleet[i].animframe=0 then
              begin
                if battlefleet[i].orient=1 then
                begin
                  csw:=spritesr[plr[rsid].team].Width;
                  csh:=spritesr[plr[rsid].team].Height;
                  {tpngs:=TPortableNetworkGraphic.Create;
                  tpngs.Width:=csw;
                  tpngs.Height:=csh;
                  tpngs.Canvas.CopyRect(rect(0,0,csw,csh),spritesr[plr[rsid].team].Canvas,
                                         rect(0,0,csw,csh));}
                  cv:=1;
                end
                else
                begin
                  csw:=spritesl[plr[rsid].team].Width;
                  csh:=spritesl[plr[rsid].team].Height;
                  //tpngs:=TPortableNetworkGraphic.Create;
                  //tpngs.Width:=csw;
                  //tpngs.Height:=csh;
                  {tpngs.Canvas.CopyRect(rect(0,0,csw,csh),spritesl[plr[rsid].team].Canvas,
                                         rect(0,0,csw,csh));}
                  cv:=2;
                end;
                if bselship=i then
                begin
                  Pen.Color:=clRed;
                  Pen.Width:=3;
                  MoveTo(round(battlefleet[i].x1*bfscl),
                         round((battlefleet[i].y1+3)*bfscl));
                  LineTo(round(battlefleet[battlefleet[i].ctid].x1*bfscl),
                         round(battlefleet[battlefleet[i].ctid].y1*bfscl));
                  MoveTo(round(battlefleet[i].x1*bfscl),
                         round((battlefleet[i].y1-3)*bfscl));
                  LineTo(round(battlefleet[battlefleet[i].ctid].x1*bfscl),
                         round(battlefleet[battlefleet[i].ctid].y1*bfscl));
                  Pen.Color:=clLime;
                  Brush.Style:=bsClear;
                  Ellipse(round((battlefleet[i].x1-round(csw/2))*bfscl),
                          round((battlefleet[i].y1-round(csh/2))*bfscl),
                          round((battlefleet[i].x1+round(csw/2))*bfscl),
                          round((battlefleet[i].y1+round(csh/2))*bfscl));
                end;
                if battlefleet[i].tp=0 then
                begin
                  if cv=1 then
                  CopyRect(rect(round((battlefleet[i].x1-csw/2)*bfscl),
                                round((battlefleet[i].y1-csh/2)*bfscl),
                                round((battlefleet[i].x1+csw/2)*bfscl),
                                round((battlefleet[i].y1+csh/2)*bfscl)),
                           spritesr[plr[rsid].team].Canvas,rect(0,0,csw,csh));
                  if cv=2 then
                  CopyRect(rect(round((battlefleet[i].x1-csw/2)*bfscl),
                                round((battlefleet[i].y1-csh/2)*bfscl),
                                round((battlefleet[i].x1+csw/2)*bfscl),
                                round((battlefleet[i].y1+csh/2)*bfscl)),
                           spritesl[plr[rsid].team].Canvas,rect(0,0,csw,csh));
                end;
                if battlefleet[i].tp=1 then
                begin
                  if cv=1 then
                  CopyRect(rect(round((battlefleet[i].x1-csw/2)*bfscl),
                                round((battlefleet[i].y1-csh/2)*bfscl),
                                round((battlefleet[i].x1+csw/2)*bfscl),
                                round((battlefleet[i].y1+csh/2)*bfscl)),
                           bsspritesr[plr[rsid].team].Canvas,rect(0,0,csw,csh));
                  if cv=2 then
                  CopyRect(rect(round((battlefleet[i].x1-csw/2)*bfscl),
                                round((battlefleet[i].y1-csh/2)*bfscl),
                                round((battlefleet[i].x1+csw/2)*bfscl),
                                round((battlefleet[i].y1+csh/2)*bfscl)),
                           bsspritesl[plr[rsid].team].Canvas,rect(0,0,csw,csh));
                end;
                //FreeAndNil(tpngs);
              end
              else
              begin
                csw:=spritesexpl[battlefleet[i].animframe].Width;
                csh:=spritesexpl[battlefleet[i].animframe].Height;
                CopyRect(rect(round((battlefleet[i].x1-csw/2)*bfscl),
                              round((battlefleet[i].y1-csh/2)*bfscl),
                              round((battlefleet[i].x1+csw/2)*bfscl),
                              round((battlefleet[i].y1+csh/2)*bfscl)),
                         spritesexpl[battlefleet[i].animframe].Canvas,
                         rect(0,0,csw,csh));
                battlefleet[i].animframe:=battlefleet[i].animframe-1;
              end;
              Pen.Color:=clLime;
              Brush.Color:=clBlack;
              Brush.Style:=bsSolid;
              Rectangle(round((battlefleet[i].x1-csw/2)*bfscl),
                        round((battlefleet[i].y1-((csh/2)+5))*bfscl),
                        round((battlefleet[i].x1+csw/2)*bfscl),
                        round((battlefleet[i].y1-((csh/2)+11))*bfscl));
              //shield bar
              Rectangle(round((battlefleet[i].x1-csw/2)*bfscl),
                        round((battlefleet[i].y1-((csh/2)+11))*bfscl),
                        round((battlefleet[i].x1+csw/2)*bfscl),
                        round((battlefleet[i].y1-((csh/2)+17))*bfscl));
              Pen.Color:=clBlue;
              Brush.Color:=clBlue;
              bfhpk:=round(csw*battlefleet[i].shield/bbasehp);
              Rectangle(round((battlefleet[i].x1-csw/2)*bfscl),
                        round((battlefleet[i].y1-((csh/2)+11))*bfscl),
                        round((battlefleet[i].x1+(bfhpk-csw/2))*bfscl),
                        round((battlefleet[i].y1-((csh/2)+17))*bfscl));
              //HP bar
              if battlefleet[i].tp=0 then
              begin
                Pen.Color:=clWhite;
                Brush.Color:=clLime;
                bfhpk:=round(csw*battlefleet[i].hp/bbasehp);
                Rectangle(round((battlefleet[i].x1-csw/2)*bfscl),
                          round((battlefleet[i].y1-((csh/2)+5))*bfscl),
                          round((battlefleet[i].x1+(bfhpk-csw/2))*bfscl),
                          round((battlefleet[i].y1-((csh/2)+11))*bfscl));
              end;
              if battlefleet[i].tp=1 then
              begin
                Pen.Color:=clRed;
                Brush.Color:=clLime;
                bfhpk:=round(csw*battlefleet[i].hp/round(bbasehp*bbshpmult));
                Rectangle(round((battlefleet[i].x1-csw/2)*bfscl),
                          round((battlefleet[i].y1-((csh/2)+5))*bfscl),
                          round((battlefleet[i].x1+(bfhpk-csw/2))*bfscl),
                          round((battlefleet[i].y1-((csh/2)+11))*bfscl));
              end;
              //hptxt
              Brush.Style:=bsClear;
              Font.Color:=clWhite;
              Font.Size:=round(20*bfscl);
              if battlefleet[i].orient=1 then
                TextOut(round((battlefleet[i].x1+csw/2)*bfscl),
                        round((battlefleet[i].y1-((csh/2)+Font.Size*2))*bfscl),
                        battlefleet[i].hptxt);
              if battlefleet[i].orient=2 then
                TextOut(round(((battlefleet[i].x1-csw/2)-(length(battlefleet[i].hptxt)*Font.Size))*bfscl),
                        round((battlefleet[i].y1-((csh/2)+Font.Size*2))*bfscl),
                        battlefleet[i].hptxt);
              Brush.Style:=bsSolid;;


            end;
          end;
          Pen.Width:=round(2*bfscl);
          if Pen.Width=0 then Pen.Width:=1;
          if beams[i].alive=true then
          begin
            Pen.Color:=beams[i].color;
            MoveTo(round(beams[i].x1*bfscl),round(beams[i].y1*bfscl));
            LineTo(round(beams[i].tx*bfscl),round(beams[i].ty*bfscl));
          end;
          Pen.Color:=clAqua;
          Brush.Color:=clWhite;
          Pen.Width:=1;
          if missiles[i].alive=true then
          begin
            Brush.Style:=bsSolid;
            Pen.Color:=clAqua;
            Brush.Color:=clWhite;
            Ellipse(round((missiles[i].x1-3)*bfscl),round((missiles[i].y1-3)*bfscl),
                    round((missiles[i].x1+3)*bfscl),round((missiles[i].y1+3)*bfscl));
            //MoveTo(missiles[i].x1,missiles[i].y1);
            //Pen.Width:=1;
            //Pen.Color:=clLime;
            //LineTo(missiles[i].x1,missiles[i].y1);
            Brush.Style:=bsClear;
            Rectangle(round((battlefleet[missiles[i].tid].x1-round(missiles[i].spd))*bfscl),
                      round((battlefleet[missiles[i].tid].y1-round(missiles[i].spd))*bfscl),
                      round((battlefleet[missiles[i].tid].x1+round(missiles[i].spd))*bfscl),
                      round((battlefleet[missiles[i].tid].y1+round(missiles[i].spd))*bfscl));
            //TextOut(missiles[i].x1+2,missiles[i].y1-scl,inttostr(missiles[i].x1)+
            //        ','+IntToStr(missiles[i].y1));
          end;
          if plasma[i].alive=true then
          begin
            Brush.Style:=bsSolid;
            if plasma[i].animstep<5 then
              Pen.Color:=clAqua;
            if plasma[i].animstep>=5 then
              Pen.Color:=clBlue;
            Brush.Color:=clAqua;

            Ellipse(round((plasma[i].x1-plasma[i].animstep)*bfscl),round((plasma[i].y1-plasma[i].animstep)*bfscl),
                    round((plasma[i].x1+plasma[i].animstep)*bfscl),round((plasma[i].y1+plasma[i].animstep)*bfscl));
            plasma[i].animstep:=plasma[i].animstep+1;
            if plasma[i].animstep>10 then plasma[i].animstep:=0;
            //MoveTo(missiles[i].x1,missiles[i].y1);
            //Pen.Width:=1;
            //Pen.Color:=clLime;
            //LineTo(missiles[i].x1,missiles[i].y1);
            Brush.Style:=bsClear;
            //Rectangle(round((battlefleet[plasma[i].tid].x1-round(plasma[i].spd))*bfscl),
            //          round((battlefleet[plasma[i].tid].y1-round(plasma[i].spd))*bfscl),
            //          round((battlefleet[plasma[i].tid].x1+round(plasma[i].spd))*bfscl),
            //          round((battlefleet[plasma[i].tid].y1+round(plasma[i].spd))*bfscl));
            //TextOut(missiles[i].x1+2,missiles[i].y1-scl,inttostr(missiles[i].x1)+
            //        ','+IntToStr(missiles[i].y1));
          end;
        end;
        fbmp.canvas.CopyRect(rect(xf,yf,wf+xf,hf+yf),rbmp.Canvas,rect(0,0,wf,hf));
        FreeAndNil(rbmp);
        //Application.ProcessMessages;
      end;


      //selected ship info
      if bselship<>-1 then
      begin
        csw:=spritesr[plr[battlefleet[bselship].owner].team].Width;
        csh:=spritesr[plr[battlefleet[bselship].owner].team].Height;
        cpw:=round(iw*0.6);
        cph:=(csh);
        Font.Size:=round(cph/4);
        Brush.Color:=clSkyBlue;
        Brush.Style:=bsSolid;
        Pen.Color:=plr[battlefleet[bselship].owner].color;
        sntlcx:=(round((iw)/2-(cpw/2)));
        sntlcy:=ih-cph-20;
        Rectangle(sntlcx,sntlcy,sntlcx+cpw,sntlcy+cph);

        if battlefleet[bselship].tp=0 then
          CopyRect(rect(round((sntlcx)),
                        round((sntlcy)),
                        round((sntlcx+csw)),
                        round((sntlcy+csh))),
                        spritesr[plr[battlefleet[bselship].owner].team].Canvas,
                        rect(0,0,spritesr[plr[battlefleet[bselship].owner].team].Width,spritesr[plr[battlefleet[bselship].owner].team].Height));
        if battlefleet[bselship].tp=1 then
          CopyRect(rect(round((sntlcx)),
                        round((sntlcy)),
                        round((sntlcx+csw)),
                        round((sntlcy+csh))),
                        bsspritesr[plr[battlefleet[bselship].owner].team].Canvas,
                        rect(0,0,bsspritesr[plr[battlefleet[bselship].owner].team].Width,bsspritesr[plr[battlefleet[bselship].owner].team].Height));

        Font.Color:=clBlack;
        Brush.Style:=bsClear;
        if battlefleet[bselship].tp=1 then
          TextOut(sntlcx+csw,sntlcy,strarr[166]+strarr[167]);
        if battlefleet[bselship].tp=0 then
          TextOut(sntlcx+csw,sntlcy,strarr[166]+strarr[168]);
        TextOut(sntlcx+csw,sntlcy+Font.Size+3,strarr[169]+inttostr(battlefleet[bselship].hp));
        TextOut(sntlcx+csw,sntlcy+Font.Size*2+3,strarr[170]+inttostr(battlefleet[bselship].shield));
      end;

      //END OF COMBAT DISPLAY

    end;
    //battle summary panel
    if (sr=true) or (cm=true) then
      begin
        Brush.Color:=clSkyBlue;
        Brush.Style:=bsSolid;
        if as1>as2 then
          Pen.Color:=battlefleet[0].color;
        if as1<as2 then
          Pen.Color:=battlefleet[bp1].color;
        if as1=as2 then
          Pen.Color:=plr[apl].color;
        Font.Size:=round((iw/30));
        cpw:=(length(inttostr(as1)+inttostr(as2))*round(Font.Size/1.3)+50)-20;
        cph:=(20+round(2*Font.Size));
        Rectangle((round((iw)/2-(cpw/2))),20,(round((iw)/2+(cpw/2))),cph+20);
        Font.Color:=battlefleet[0].color;
        Brush.Style:=bsClear;
        TextOut((round((iw)/2-(cpw/2))+5),21,inttostr(as1));
        Brush.Style:=bsSolid;
        Font.Color:=battlefleet[bp1].color;
        Brush.Style:=bsClear;
        TextOut(round((iw)/2-(cpw/2))+1+(length(inttostr(as1))*(round(Font.Size/1.3)))+10,21,inttostr(as2));
        Brush.Style:=bsSolid;
        //sr:=false;
      end;
    //popups
    if CheckBox3.Checked=true then
    begin
      Brush.Style:=bsClear;
      Font.Color:=clLime;
      Font.Size:=round(scl/4);
      for i:=0 to 100 do
      begin
        with pop[i] do
          if active=true then
            TextOut(round(x*scl-camx),round(y*scl-camy),text);
      end;
    end;
  end;
  //---FINAL OUTPUT---
  Image1.Canvas.CopyRect(rect(0,0,iw,ih),fbmp.Canvas,rect(0,0,iw,ih));
  freeandnil(globalbmp);
  freeandnil(fbmp);

  //---Windows controls--
  //---Main window---
    SpeedButton1.Caption:=strarr[1]+' ('+inttostr(bclmc)+'/'+inttostr(bclpc)+')';
    SpeedButton2.Caption:=strarr[2]+' ('+inttostr(plr[apl].fleetcost)+'/'+inttostr(sfcp)+')';
    GroupBox1.Caption:=strarr[5];
    GroupBox2.Caption:=strarr[10];
    Label1.Caption:=strarr[6]+': '+inttostr(moneypool[apl]);
    Label2.Caption:=strarr[7]+': '+inttostr(calcplayerprofit(apl));
    Label3.Caption:=strarr[8]+': '+inttostr(calcplayerexp(apl));
    Label4.Caption:=strarr[9]+': '+inttostr(productpool[apl]);
    if field[acagex,acagey].m<>0 then
      SpeedButton3.Caption:=strarr[3]+' ('+inttostr(round(sqr(field[acagex,acagey].m)*bassecm))+'/'+inttostr(round(sqr(field[acagex,acagey].m)*bassecm))+')';
    if field[acagex,acagey].p<>0 then
      SpeedButton3.Caption:=strarr[3]+' ('+inttostr(round(sqr(field[acagex,acagey].p)*bassecm))+'/'+inttostr(round(sqr(field[acagex,acagey].p)*bassecm))+')';
    if (field[acagex,acagey].p=0) and ((field[acagex,acagey].m=0)) then
      SpeedButton3.Caption:=strarr[3]+' (0/0)';
    SpeedButton6.Caption:=strarr[4]+' ('+inttostr(fleets[afleet].power*10)+'/'+inttostr(fleets[afleet].power)+')';
    SpeedButton17.Caption:=strarr[141]+' ('+inttostr((fleets[afleet].battleships+1)*bbscostm)+'/'+inttostr((fleets[afleet].battleships+1)*bbscostp)+')';
    CheckBox1.Caption:=strarr[12];
    CheckBox2.Caption:=strarr[13];
    CheckBox3.Caption:=strarr[14];
    CheckBox4.Caption:=strarr[15];
    CheckBox5.Caption:=strarr[16];
    CheckBox6.Caption:=strarr[147];
    Label5.Caption:=Strarr[17];
    SpeedButton4.Caption:=strarr[19];
    SpeedButton5.Caption:=strarr[18];
    SpeedButton7.Caption:=strarr[11];
    SpeedButton16.Caption:=strarr[123];
    MenuItem1.Caption:=strarr[20];
    MenuItem2.Caption:=strarr[23];
    MenuItem3.Caption:=strarr[22];
    MenuItem4.Caption:=strarr[21];
    MenuItem5.Caption:=strarr[139];
    MenuItem6.Caption:=strarr[140];
    MenuItem7.Caption:=strarr[155];
  //---Trade window---
    with form4 do
    begin
      Caption:=strarr[11];
      Label1.Caption:=strarr[47]+': '+inttostr(pprice);
      Label3.Caption:=strarr[48]+': '+inttostr(productpool[apl]);
      Label4.Caption:=strarr[49]+': '+inttostr(moneypool[apl]);
      Label5.Caption:=strarr[152];
      Label6.Caption:=inttostr(plr[apl].sperc)+'%';
      Label7.Caption:=Strarr[150]+' '+inttostr(
                      round(calcplayerproduct(apl)))+
                      ' '+Strarr[149]+' '+
                      inttostr(round(calcplayerproduct(apl)*bbprodsc));
      SpeedButton1.Caption:=strarr[99];
      SpeedButton2.Caption:=strarr[98];
      SpeedButton3.Caption:=strarr[97];
      GroupBox1.Caption:=strarr[11];
      GroupBox2.Caption:=strarr[95];
      GroupBox3.Caption:=strarr[151];
      GroupBox5.Caption:=strarr[163];
      if field[acagex,acagey].b=0 then
      begin
        Button1.Caption:=strarr[164]+' ('+inttostr(round(barc/5))+')';
        ListBox1.Enabled:=true;
        //Image1.Picture.LoadFromFile();
      end
      else
      begin
        Button1.Caption:=strarr[165]+' ('+inttostr(round(barc/5))+')';
        ListBox1.Enabled:=false;
      end;
      Label2.Caption:=strarr[96];
    end;
  //locale editor
    with form7 do
    begin
      Label1.Caption:=strarr[105];
      Button1.Caption:=strarr[102];
      Button2.Caption:=strarr[104];
      Button3.Caption:=strarr[103];
    end;
  //research window
    with form8 do
    begin
      BitBtn1.Caption:=strarr[117]+' ('+inttostr(barc*sqr(plr[apl].tech[0]))+')';
      BitBtn2.Caption:=strarr[117]+' ('+inttostr(barc*sqr(plr[apl].tech[1]))+')';
      BitBtn3.Caption:=strarr[117]+' ('+inttostr(barc*sqr(plr[apl].tech[2]))+')';
      BitBtn4.Caption:=strarr[117]+' ('+inttostr(barc*sqr(plr[apl].tech[3]))+')';
      BitBtn5.Caption:=strarr[117]+' ('+inttostr(barc*sqr(plr[apl].tech[4]))+')';
      Label2.Caption:=strarr[118];
      Label3.Caption:=strarr[119];
      Label4.Caption:=strarr[120];
      Label5.Caption:=strarr[121];
      Label6.Caption:=strarr[122];
      GroupBox1.Caption:=strarr[124];
    end;
  //extended battle info
    with form9 do
    begin
       Memo1.Clear;
       Memo2.Clear;
       if plr[cbt1].name<>'' then
         GroupBox1.Caption:=plr[cbt1].name
       else
         GroupBox1.Caption:=strarr[27]+': '+inttostr(cbt1);
       if plr[cbt2].name<>'' then
         GroupBox2.Caption:=plr[cbt2].name
       else
         GroupBox2.Caption:=strarr[27]+': '+inttostr(cbt2);
       Memo1.Lines.Add(strarr[127]+inttostr(as1));
       Memo1.Lines.Add(strarr[128]+floattostr(bab1));
       Memo1.Lines.Add(strarr[129]+floattostr(bdb1));
       Memo1.Lines.Add(strarr[130]+inttostr(plr[cbt1].tech[0]));
       Memo1.Lines.Add(strarr[131]+inttostr(plr[cbt1].tech[1]));
       Memo1.Lines.Add(strarr[132]+inttostr(plr[cbt1].tech[2]));
       Memo2.Lines.Add(strarr[127]+inttostr(as2));
       Memo2.Lines.Add(strarr[128]+floattostr(bab2));
       Memo2.Lines.Add(strarr[129]+floattostr(bdb2));
       Memo2.Lines.Add(strarr[130]+inttostr(plr[cbt2].tech[0]));
       Memo2.Lines.Add(strarr[131]+inttostr(plr[cbt2].tech[1]));
       Memo2.Lines.Add(strarr[132]+inttostr(plr[cbt2].tech[2]));
    end;
    //briefing window
      Form12.Button1.Caption:=strarr[154];


end;


function Tform1.getmyfleetno(p:integer):integer;
var i,n:integer;
begin
  n:=0;
  for i:=1 to 4000 do
  begin
    if fleets[i].owner=p then n:=n+1;
  end;
  result:=n;
end;

function Tform1.getaveragefleetno:integer;
var i,npl,nfl:integer;
begin
  npl:=0; nfl:=0;
  for i:=0 to 10 do
    if Form1.PlayerHasCages(i)=true then npl:=npl+1;
  for i:=0 to 10 do
     nfl:=nfl+getmyfleetno(i);
  result:=round(nfl/npl);
end;

procedure TForm1.MenuItem3Click(Sender: TObject);
begin
  Form5.Show;
end;

procedure TForm1.CheckForBS(x,y,atp:integer);
var i:integer;
    qcx1,qcy1,qcx2,qcy2:integer;
begin
  if atp=0 then bselship:=-1;
  for i:=0 to maxo do
  begin
    qcx1:=battlefleet[i].x1-25;
    qcy1:=battlefleet[i].y1-25;
    qcx2:=battlefleet[i].x1+25;
    qcy2:=battlefleet[i].y1+25;
    if (x>qcx1) and (x<qcx2) and (y>qcy1) and (y<qcy2) then
     begin
       if atp=0 then
         bselship:=i;
       if (atp=1) and (plr[battlefleet[bselship].owner].human=true) then
       begin
         battlefleet[bselship].ctid:=i;
       end;
     end;
  end;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var btnid:integer;
begin
  Form11.Button9.Click;
  if (mm=false) and (Button=mbLeft) and (checkforbutton(x,y)=0) then
  begin
    cx:=round(((camx+x)/scl-0.5));
    cy:=round(((camy+y)/scl-0.5));
    acagex:=cx;
    acagey:=cy;
    afleet:=checkforfleet(acagex,acagey).id;
  end;
  if (mm=false) and ((cmkx<>0) or (cmky<>0)) then
  begin
    MoveFleet(checkforfleet(ctx,cty).id,cmkx,cmky);
    cmkx:=0;
    cmky:=0;
  end;
  if sr=true then sr:=false;
  btnid:=checkforbutton(x,y);
  if (btnid<>0) and (cm=false) then
  begin
    GButtonPress(btnid);
//    buts[btnid].state:=;
  end;
  //if (mm=true) and (btnid=0) and (Button=mbLeft) then Form2.Show;
  if (cm=true) then
  begin
    if Button=mbLeft then
      CheckForBS(round(x/bfscl),round(y/bfscl),0);
    if Button=mbMiddle then
      CheckForBS(round(x/bfscl),round(y/bfscl),1);
    //form9.Show;
  end;
  Form4.Loadbuildinginfo(field[acagex,acagey].b);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  //first launch!
  //HEAPTRC.
  randomize;
  cleanpopups;
  PreloadSprites;
  //cleangamedata;
  //startgame(3,true);
  //maxpl:=3;
  //Redraw;
  basloc:=-1;

end;


procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var btnid,i:integer;
begin
  btnid:=checkforbutton(x,y);
  for i:=1 to 20 do
  begin
    if (i=btnid) and (btnid<>0) then
    begin
      buts[i].state:=1;
      //ShowMessage('FUCKIN` BUTTON!!!');
    end
    else
    begin
      buts[i].state:=0;
    end;
  end;
  if mm=false then
  begin
    cx:=round(((camx+x)/scl-0.5));
    cy:=round(((camy+y)/scl-0.5));
    if (ssLeft in shift) and (checkforfleet(ctx,cty).owner<>-1) then
    begin
      if ((cx-ctx)<0) and ((cy-cty)=0) then
      begin
        cmkx:=-1;
        cmky:=0;
      end;
      if ((cx-ctx)<0) and ((cy-cty)<0) then
      begin
        cmkx:=-1;
        cmky:=-1;
      end;
      if ((cx-ctx)=0) and ((cy-cty)<0) then
      begin
        cmkx:=0;
        cmky:=-1;
      end;
      if ((cx-ctx)=0) and ((cy-cty)=0) then
      begin
        cmkx:=0;
        cmky:=0;
      end;
      if ((cx-ctx)>0) and ((cy-cty)=0) then
      begin
        cmkx:=1;
        cmky:=0;
      end;
      if ((cx-ctx)>0) and ((cy-cty)>0) then
      begin
        cmkx:=1;
        cmky:=1;
      end;
      if ((cx-ctx)=0) and ((cy-cty)>0) then
      begin
        cmkx:=0;
        cmky:=1;
      end;
      if ((cx-ctx)<0) and ((cy-cty)>0) then
      begin
        cmkx:=-1;
        cmky:=1;
      end;
      if ((cx-ctx)>0) and ((cy-cty)<0) then
      begin
        cmkx:=1;
        cmky:=-1;
      end;
    end
    else
    begin
      cmkx:=0;
      cmky:=0;
    end;
    if ssMiddle in Shift then
    begin
      camx:=camx-(x-mxp);
      camy:=camy-(y-myp);
      myp:=y; mxp:=x;
    end;
  end;
end;

procedure TForm1.AIMoveFleetToNearestUnclaimed(fx,fy,pf:integer);
var d,dm,dx,dy,mx,my:integer;
    kx,ky:integer;
    i,j:integer;
    snf:fleet;
begin
  dm:=1000;
  if random(10)>5 then
  begin
    for i:=0 to (gw-1) do
    for j:=0 to (gh-1) do
    begin
      if (abs(i-fleets[pf].x)<2) and (abs(j-fleets[pf].y)<2) then
        snf:=getstrongestnearbyfleet(i,j,fleets[pf].owner)
      else
      begin
        snf.owner:=-1;
        snf.power:=0;
      end;
      dx:=fx-i;
      dy:=fy-j;
      d:=round(sqrt(sqr(dx)+sqr(dy)));
      if (d<dm) and (field[i,j].o<>fleets[pf].owner)
         and ((field[i,j].m>0) or ((field[i,j].p>0)))
         and ((snf.power<fleets[pf].power)
            or (snf.owner=-1) or (snf.owner=fleets[pf].owner)) then
      begin
        dm:=d;
        mx:=i; my:=j;
        if mx<fx then kx:=-1;
        if mx=fx then kx:=0;
        if mx>fx then kx:=1;
        if my<fy then ky:=-1;
        if my=fy then ky:=0;
        if my>fy then ky:=1;
      end;
      if (d=dm) and (field[i,j].o<>fleets[pf].owner) and (field[i,j].p>field[mx,my].p)
         and ((field[i,j].m>0) or ((field[i,j].p>0)))
         and ((snf.power<fleets[pf].power)
            or (snf.owner=-1) or (snf.owner=fleets[pf].owner)) then
      begin
        dm:=d;
        mx:=i; my:=j;
        if mx<fx then kx:=-1;
        if mx=fx then kx:=0;
        if mx>fx then kx:=1;
        if my<fy then ky:=-1;
        if my=fy then ky:=0;
        if my>fy then ky:=1;
      end;
    end;
  end
  else
  begin
    for i:=(gw-1) downto (0) do
    for j:=(gh-1) downto (0) do
    begin
      if (abs(i-fleets[pf].x)<2) and (abs(j-fleets[pf].y)<2) then
        snf:=getstrongestnearbyfleet(i,j,fleets[pf].owner)
      else
      begin
        snf.owner:=-1;
        snf.power:=0;
      end;
      dx:=fx-i;
      dy:=fy-j;
      d:=round(sqrt(sqr(dx)+sqr(dy)));
      if (d<dm) and (field[i,j].o<>fleets[pf].owner)
         and ((getfp(snf)<getfp(fleets[pf]))
            or (snf.owner=-1) or (snf.owner=fleets[pf].owner)) then
      begin
        dm:=d;
        mx:=i; my:=j;
        if mx<fx then kx:=-1;
        if mx=fx then kx:=0;
        if mx>fx then kx:=1;
        if my<fy then ky:=-1;
        if my=fy then ky:=0;
        if my>fy then ky:=1;
      end;
      if (d=dm) and (field[i,j].o<>fleets[pf].owner) and (field[i,j].p>field[mx,my].p)
         and ((GetFP(snf)<GetFP(fleets[pf]))
            or (snf.owner=-1) or (snf.owner=fleets[pf].owner)) then
      begin
        dm:=d;
        mx:=i; my:=j;
        if mx<fx then kx:=-1;
        if mx=fx then kx:=0;
        if mx>fx then kx:=1;
        if my<fy then ky:=-1;
        if my=fy then ky:=0;
        if my>fy then ky:=1;
      end
    end;
  end;
  //ShowMessage('Ai moves fleet '+inttostr(pf)+' with kx='+inttostr(kx)+' and ky='
  //            +inttostr(ky)+' (mx='+inttostr(mx)+', my='+inttostr(my));

  MoveFleet(pf,kx,ky);
end;

procedure TForm1.AIMoveFleetToNearestClaimed(fx,fy,pf:integer);
var d,dm,dx,dy,mx,my:integer;
    kx,ky:integer;
    i,j:integer;
    snf:fleet;
begin
  dm:=100;
  for i:=0 to (gw-1) do
  for j:=0 to (gh-1) do
  begin
    if (abs(i-fleets[pf].x)<basflap) and (abs(j-fleets[pf].y)<basflap) then
      snf:=getstrongestnearbyfleet(i,j,fleets[pf].owner)
    else
    begin
      snf.owner:=-1;
      snf.power:=0;
    end;
    dx:=fx-i;
    dy:=fy-j;
    d:=round(sqrt(sqr(dx)+sqr(dy)));
    if (d<dm) and (field[i,j].o=fleets[pf].owner)
       and ((getfp(snf)<getfp(fleets[pf]))
            or (snf.owner=-1) or (snf.owner=fleets[pf].owner)) then
    begin
      dm:=d;
      mx:=i; my:=j;
      if mx<fx then kx:=-1;
      if mx=fx then kx:=0;
      if mx>fx then kx:=1;
      if my<fy then ky:=-1;
      if my=fy then ky:=0;
      if my>fy then ky:=1;
    end;
    if (d=dm) and (field[i,j].o=fleets[pf].owner) and (random(2)=0)
       and ((getfp(snf)<getfp(fleets[pf]))
            or (snf.owner=-1) or (snf.owner=fleets[pf].owner)) then
    begin
      dm:=d;
      mx:=i; my:=j;
      if mx<fx then kx:=-1;
      if mx=fx then kx:=0;
      if mx>fx then kx:=1;
      if my<fy then ky:=-1;
      if my=fy then ky:=0;
      if my>fy then ky:=1;
    end;
  end;
  //ShowMessage('Ai moves fleet '+inttostr(pf)+' with kx='+inttostr(kx)+' and ky='
  //            +inttostr(ky)+' (mx='+inttostr(mx)+', my='+inttostr(my));
  MoveFleet(pf,kx,ky);
end;

function TForm1.getstrongestnearbyfleet(x,y,p:integer):fleet;
var i,j:integer;
    dfn,dfp:integer;
    tf:fleet;
begin
  dfp:=0;
  dfn:=-1;
  for i:=(x-1) to (x+1) do
  for j:=(y-1) to (y+1) do
  begin
    tf:=checkforfleet(i,j);
    if (i=x) and (j=y) then
    begin end else begin
      if tf.owner<>-1 then
      begin
        if getfp(tf)>dfp then
        begin
          dfp:=getfp(tf);
          dfn:=tf.id;
        end;
      end;
    end;
  end;
  if dfn<>-1 then
    result:=fleets[dfn]
  else
  begin
    result.owner:=-1;
    //result
  end;
end;

function TForm1.playerhasfleets(p:integer):boolean;
var i,n:integer;
begin
  n:=0;
  for i:=1 to 4000 do
  begin
    if fleets[i].owner=p then n:=n+1;
  end;
  if n=0 then  result:=false else result:=true;
end;


procedure TForm1.AIForcedMoveFleet(gx,gy:integer;flt:fleet);
var kx,ky:integer;
begin
  //moves fleet to desired coords no matter of circumstances
  if gx>flt.x then kx:=1;
  if gx<flt.x then kx:=-1;
  if gx=flt.x then kx:=0;
  if gy>flt.y then ky:=1;
  if gy<flt.y then ky:=-1;
  if gy=flt.y then ky:=0;
  MoveFleet(flt.id,kx,ky);
end;

procedure TForm1.AIMoveConcerningEnemyFleet(pflt,eflt:fleet);
var i,j,kx,ky:integer;
    mind,mindx,mindy,efp:integer;
begin
  //moves fleet away from anemy if week or equal, attacks if stronger

  if getfp(eflt)<getfp(pflt) then
  begin
    //ShowMessage('Attacking!');
    if eflt.x>pflt.x then kx:=1;
    if eflt.x<pflt.x then kx:=-1;
    if eflt.x=pflt.x then kx:=0;
    if eflt.y>pflt.y then ky:=1;
    if eflt.y<pflt.y then ky:=-1;
    if eflt.y=pflt.y then ky:=0;
  end
  else
  begin
    //ShowMessage('Getting out!');
    GetMinimumDanger(pflt.owner,pflt.ap,pflt.x,pflt.y,mindx,mindy);
    if mindx>pflt.x then kx:=1;
    if mindx<pflt.x then kx:=-1;
    if mindx=pflt.x then kx:=0;
    if mindy>pflt.y then ky:=1;
    if mindy<pflt.y then ky:=-1;
    if mindy=pflt.y then ky:=0;
  end;
  MoveFleet(pflt.id,kx,ky);
end;

function TForm1.GetNearestIntruder(fch:fleet;rad:integer):fleet;
var i,j,ii,jj,mdist,dist,xr,yr,pr,owr:integer;
    ef,exf:fleet;
begin
  mdist:=rad;
  with exf do
  begin
    x:=-1;
    y:=-1;
    owner:=-1;
    id:=-1;
    power:=-1;
  end;
  for i:=0 to (gw-1) do
  for j:=0 to (gh-1) do
  begin
    ef:=getstrongestnearbyfleet(i,j,fch.owner);
    if field[i,j].o=fch.owner then
    begin
      if (ef.owner<>fch.owner) and (ef.owner<>-1) and (ef.power<=fch.power) then
      begin
        dist:=round(sqrt(sqr(fch.x-ef.x)+sqr(fch.y-ef.y)));
        if dist<mdist then
        begin
          exf:=ef;
          mdist:=dist;
        end;
      end;
    end;
  end;
  Result:=exf;
end;

procedure TForm1.ProcessAITurns;
var i,j,ckp:integer;
    topump:integer;
    fd:integer;
    mefp:integer;
    mefx:integer;
    mefy:integer;
    snf:fleet;
    intfl:fleet;
    ec:boolean;
begin
  Log('Processing AI');
  //makes AI enemy move fleets, upgrade fleets, claim tiles, trade and
  //fight
  //ShowMessage('Ai player '+inttostr(apl)+' turn');

  //STEP 1
  //AI uses fleets
  for i:=1 to 4000 do
  begin
    if fleets[i].owner=apl then
    begin
      ckp:=0;
      while fleets[i].ap>0 do
      begin
        ckp:=ckp+1;
        //0) enemy fleet is near
        if (getstrongestnearbyfleet(fleets[i].x,fleets[i].y,fleets[i].owner).owner<>-1) and
           (getstrongestnearbyfleet(fleets[i].x,fleets[i].y,fleets[i].owner).owner<>fleets[i].owner) then
        begin
          //ShowMessage('Enemy fleet is near');
          topump:=getfp(getstrongestnearbyfleet(fleets[i].x,fleets[i].y,fleets[i].owner))-round(getfp(fleets[i]));
          while topump>=-1 do
          begin
            AddBattleship(i);
            UpgradeFleet(i);
            topump:=topump-1;
          end;
          AIMoveConcerningEnemyFleet(fleets[i],getstrongestnearbyfleet(fleets[i].x,fleets[i].y,fleets[i].owner));
        end;
        //1) intercept check
        intfl:=GetNearestIntruder(fleets[i],round((gw+gh)/3));
        if (intfl.owner<>-1) and (intfl.owner<>apl) and (intfl.power<=fleets[i].power) then
        begin
          //ShowMessage('Going to intercept');
          AIForcedMoveFleet(intfl.x,intfl.y,fleets[i]);
          //ShowMessage('Intercepting fleet '+inttostr(intfl.id)+' ('+inttostr(intfl.owner)+')');
        end;
        //2) fleet is on player claimed territory
        if (field[fleets[i].x,fleets[i].y].o=apl) and (fleets[i].ap>0) then
        begin
          AIMoveFleetToNearestUnclaimed(fleets[i].x,fleets[i].y,i);
        end;
        //3) fleet is on an unclaimed territory
        if (field[fleets[i].x,fleets[i].y].o<>apl) and (fleets[i].ap>0) then
        begin
          ClaimCage(fleets[i]);
        end;
        //4) fleet is separated from claimable tiles
        AIMoveFleetToNearestClaimed(fleets[i].x,fleets[i].y,i);
        if ckp>(2*round(basflap)) then fleets[i].ap:=0;
      end;
    end;
  end;
  //STEP 2
  //AI produces fleets
  fd:=0;
  mefp:=fpowlim;
  mefx:=0;
  mefy:=0;
  if (moneypool[apl]>=plr[apl].fleetcost)
     and (calcplayerprofit(apl)>calcplayerexp(apl))
     and (productpool[apl]<sfcp) then
  begin
    Form4.BuyProduct(round(abs(moneypool[apl]-plr[apl].fleetcost)/pprice));
  end;
  if (moneypool[apl]>=plr[apl].fleetcost) and (productpool[apl]>=sfcp) then
  begin
    fd:=1;
    for i:=0 to (gw-1) do
    for j:=0 to (gw-1) do
    begin
      if (calcplayerprofit(apl)>calcplayerexp(apl)) and (field[i,j].o=apl) then
      begin
        snf:=getstrongestnearbyfleet(i,j,apl);
        if (snf.power<mefp) and (snf.owner<>-1) and (checkforfleet(i,j).owner=-1) then
        begin
          mefp:=snf.power;
          mefx:=i;
          mefy:=j;
        end;
        if snf.owner=-1 then
        begin
          BuildNewFleet(i,j,apl,plr[apl].fleetcost);
          fd:=2;
        end;
      end;
    end;
    if fd=1 then
    begin

    end;
  end;
  //STEP 3
  //AI processes owned tiles and fleets
  if ((playerhasfleets(apl)=true) and (getmyfleetno(apl)>getaveragefleetno)) or
     (random(3)=2) then
  begin
    if random(2)=0 then
    begin
      for i:=0 to (gw-1) do
      for j:=0 to (gh-1) do
      begin
        if field[i,j].o=apl then
        begin
          if ((field[i,j].p>0) and (calcplayerexp(apl)<calcplayerprofit(apl))) or
             (field[i,j].m>0) then
            UpgradeTile(i,j);
          if ((field[i,j].m>0) and (moneypool[apl]>=round(barc/5)) and (field[i,j].b=0)) then
            constructbuilding(i,j,2,apl);
          if ((field[i,j].p>0) and (moneypool[apl]>=round(barc/5)) and (field[i,j].b=0)) then
            constructbuilding(i,j,3,apl);
          if ((field[i,j].m=0) and (field[i,j].p=0) and (moneypool[apl]>=round(barc/5)) and (field[i,j].b=0)) then
          begin
            if random(2)=1 then
              constructbuilding(i,j,1,apl)
            else
              constructbuilding(i,j,4,apl)
          end;
        end;
      end;
    end
    else
    begin
      for i:=(gw-1) downto 0 do
      for j:=(gh-1) downto 0 do
      begin
        if field[i,j].o=apl then
        begin
          if ((field[i,j].p>0) and (calcplayerexp(apl)<calcplayerprofit(apl))) or
             (field[i,j].m>0) then
            UpgradeTile(i,j);
        end;
      end;
    end;
    for i:=1 to 4000 do
    begin
      if (fleets[i].owner=apl) and (calcplayerprofit(apl)>calcplayerexp(apl))
      then begin UpgradeFleet(i); AddBattleship(i); end;
    end;
  end;
  //STEP 4
  //AI sells or buys some product
  Form4.SellProduct(random(productpool[apl]));
  //STEP 5
  //AI attempts to research his techs
  ResearchTech(apl,0);
  ResearchTech(apl,1);
  ResearchTech(apl,2);
  ResearchTech(apl,3);
  ResearchTech(apl,4);
  //STEP 6
  //AI adjusts product generation finances
  ec:=false;
  repeat
    plr[apl].sperc:=plr[apl].sperc-1;
    if ((calcplayerprofit(apl)>=calcplayerexp(apl)) or (plr[apl].sperc<=0)) then ec:=true;
  until (ec=true);
  ec:=false;
  if (calcplayerprofit(apl)>calcplayerexp(apl)) and (moneypool[apl]>(calcplayerexp(apl)*3)) then
  begin
    repeat
      plr[apl].sperc:=plr[apl].sperc+1;
      if ((calcplayerprofit(apl)<=calcplayerexp(apl)) or (plr[apl].sperc>=100)) then ec:=true;
    until (ec=true);
  end;
  if plr[apl].sperc<0 then plr[apl].sperc:=0;
  if plr[apl].sperc>100 then plr[apl].sperc:=100;
  Application.ProcessMessages;
end;

procedure TForm1.EndTurn;
var i:integer;
begin
  Log('End turn attempt');
  if (mm=false) and (ig=true) and (cm=false) then
  begin
    Log('Reading endturn...');
    moneypool[apl]:=moneypool[apl]+Calcplayerprofit(apl);
    moneypool[apl]:=moneypool[apl]-Calcplayerexp(apl);
    productpool[apl]:=productpool[apl]+calcplayerproduct(apl);
    statseries[apl].AddXY(turn,form3.Calculateprosperity(apl,false,true),'',plr[apl].color);
    apl:=apl+1;
    {MessageDlg('Turn results. Treasury:'+inttostr(moneypool[apl])+'. Income: '+
               inttostr(Calcplayerprofit(apl))+'. Expences: '+inttostr(Calcplayerexp(apl)),
               mtInformation,[mbOK],0);}
    if apl>(maxpl-1) then
    begin
      apl:=0;
      turn:=turn+1;
    end;
    for i:=1 to 4000 do
    begin
      fleets[i].ap:=round(basflap);
    end;
    //switching product price
    psx:=psx+1;
    priceseries.AddXY(psx,pprice,'',clRed);
    if random(2)=0 then
      pprice:=pprice+round((random(prflux)/100)*pprice)
    else
      pprice:=pprice-round((random(prflux)/100)*pprice);
    if pprice<=minpprice then pprice:=minpprice;
    if pprice>maxpprice then pprice:=maxpprice;
    //checking if current player is dead
    if PlayerHasCages(apl)=false then EndTurn;
    if plr[apl].human=false then
    begin
      Log('ET sends to Process AI turns...');
      ProcessAITurns;
      EndTurn;
    end;
  end;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
  //Log('Showing');

end;

function TForm1.TileHasNearbyClaimed(tx,ty,p:integer):boolean;
var i,j:integer; r:boolean;
begin
  r:=false;
  for i:=(tx-1) to (tx+1) do
  for j:=(ty-1) to (ty+1) do
  begin
    if (field[i,j].o=p) then
    begin
      if (i<=(gw-1)) and (j<=(gh-1)) and (i>=0) and (j>=0) then
        r:=true;
    end;
  end;
  //if r=true then
  //ShowMessage(inttostr(tx)+','+inttostr(ty)+' has NBC');
  result:=r;
end;

procedure TForm1.BuildNewFleet(x,y,p,fc:integer);
var i:integer=0;
begin
  Log('Build new fleet proc started');
  if (x>=0) and (x<=(gw-1)) and (y>=0) and (y<=(gh-1)) then
  begin
    if (moneypool[p]>=fc) and (productpool[p]>=sfcp) and (checkforfleet(x,y).owner=-1)
       and (field[x,y].o=p)then
    begin
      repeat
        i:=i+1;
      until (fleets[i].owner=-1) or (i=4000);
      if i=4000 then begin MessageDlg('Fleet limit reached.',mtError,[mbOK],0); end;
      if i<4000 then
      begin
        addpopup(x,y,strarr[51]);
        Log('Creating a fleet '+inttostr(i));
        moneypool[p]:=moneypool[p]-fc;
        productpool[p]:=productpool[p]-sfcp;
        fleets[i].x:=x; fleets[i].y:=y; fleets[i].owner:=p; fleets[i].ap:=round(basflap);
        fleets[i].power:=round(basflp);
        fleets[i].xp:=0;
        fleets[i].ab:=1;
        fleets[i].battleships:=0;
        if plr[apl].team=1 then fleets[i].ab:=1.1;
        fleets[i].db:=1;
        if plr[apl].team=3 then fleets[i].db:=1.1;
        plr[p].rfleetcost:=plr[p].rfleetcost*flcm;
        plr[p].fleetcost:=round(plr[p].rfleetcost);
        //showmessage(inttostr(plr[p].fleetcost)+'('+floattostr(plr[p].rfleetcost)+')')
      end;
    end;
    maxf:=getmaxf;
  end;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  BuildNewFleet(acagex,acagey,apl,plr[apl].fleetcost);
end;

procedure TForm1.UpgradeTile(utx,uty:integer);
begin
  Log('Upgrade Tile proc started');
  if (utx>=0) and (utx<=(gw-1)) and (uty>=0) and (uty<=(gh-1)) then
  begin
    if (field[utx,uty].o=apl) and (moneypool[apl]>=sqr(field[utx,uty].m)*bassecm)
       and (productpool[apl]>=sqr(field[utx,uty].m)*bassecm)
       and (field[utx,uty].m<smplim) and (field[utx,uty].p<smplim)
       and (field[utx,uty].m<>0) then
    begin
      moneypool[apl]:=moneypool[apl]-round(sqr(field[utx,uty].m)*bassecm);
      productpool[apl]:=productpool[apl]-round(sqr(field[utx,uty].m)*bassecm);
      //field[utx,uty].p:=field[utx,uty].p+1;
      field[utx,uty].m:=field[utx,uty].m+1;
      addpopup(utx,uty,'+1/+1');
    end;
    if (field[utx,uty].o=apl) and (moneypool[apl]>=sqr(field[utx,uty].p)*bassecm)
       and (productpool[apl]>=sqr(field[utx,uty].p)*bassecm)
       and (field[utx,uty].m<smplim) and (field[utx,uty].p<smplim)
       and (field[utx,uty].p<>0) then
    begin
      moneypool[apl]:=moneypool[apl]-round(sqr(field[utx,uty].p)*bassecm);
      productpool[apl]:=productpool[apl]-round(sqr(field[utx,uty].p)*bassecm);
      field[utx,uty].p:=field[utx,uty].p+1;
      //field[utx,uty].m:=field[utx,uty].m+1;
      addpopup(utx,uty,'+1/+1');
    end;
  end;
end;

procedure TForm1.AddBattleship(fid:integer);
begin
  Log('AddBattleship proc started');
  if (fleets[fid].owner=apl) and
     (moneypool[apl]>=round((fleets[fid].battleships+1)*bbscostm)) and
     (productpool[apl]>=round((fleets[fid].battleships+1)*bbscostp)) and
     (field[fleets[fid].x,fleets[fid].y].o=apl) and
     (fleets[fid].battleships<bbslim) then
  begin
    moneypool[apl]:=moneypool[apl]-round((fleets[fid].battleships+1)*bbscostm);
    productpool[apl]:=productpool[apl]-round((fleets[fid].battleships+1)*bbscostp);
    fleets[fid].battleships:=fleets[fid].battleships+1;
    addpopup(fleets[fid].x,fleets[fid].y,'+1');
  end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  //ShowMessage('Tlno: '+inttostr(tlno));
  if fac=0 then
  begin
    with form10 do
    begin
      if fileexists(extractfiledir(Application.ExeName)+'\gameconfig.cfg')=true then
      begin
        Memo1.Lines.LoadFromFile(extractfiledir(Application.ExeName)+'\gameconfig.cfg');
        cloc:=strtoint(form10.Memo1.Lines[0]);
        with Form7 do
        begin
          LoadLocales(cloc,1);
          ReadLocales;
        end;
      end
      else
      begin
        cloc:=0;
        with Form7 do
        begin
          LoadLocales(cloc,1);
          ReadLocales;
        end;
      end;
    end;
    Form2.Button2.Click;
    mm:=true;
    Redraw;
    fac:=1;
    ballowbriefings:=true;
  end;

end;

procedure TForm1.UpgradeFleet(fid:integer);
begin
  Log('Upgrade Fleet proc started');
  if (fleets[fid].owner=apl) and (moneypool[apl]>=fleets[fid].power*10) and (productpool[apl]>=fleets[fid].power) and
     (field[fleets[fid].x,fleets[fid].y].o=apl) and (fleets[fid].power<fpowlim) then
  begin
    moneypool[apl]:=moneypool[apl]-fleets[fid].power*10;
    productpool[apl]:=productpool[apl]-fleets[fid].power;
    fleets[fid].power:=fleets[fid].power+1;
    addpopup(fleets[fid].x,fleets[fid].y,'+1');
  end;
end;

procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
  UpgradeFleet(afleet);
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  UpgradeTile(acagex,acagey);
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  EndTurn;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
var i:integer;
begin
  {if Memo1.Visible=false then
  begin
    Memo1.Clear;
    for i:=1 to 4000 do
    begin
      Memo1.Lines.Add(inttostr(i)+') '+inttostr(fleets[i].x)+','+inttostr(fleets[i].y)+'; '+inttostr(fleets[i].owner));
    end;
    Memo1.Visible:=true;
  end
  else Memo1.Visible:=false;}
  Form3.Show;
end;

procedure TForm1.ClaimCage(claimingfleet:fleet);
var cf:fleet;
begin
  cf:=claimingfleet;
  if cf.owner=apl then
  begin
    if (field[cf.x,cf.y].o<>-1) and (cf.ap>0) and (field[cf.x,cf.y].o<>apl) and
       (TileHasNearbyClaimed(cf.x,cf.y,cf.owner)=true) then
    begin
      addpopup(cf.x,cf.y,strarr[53]);
      //showmessage('unclaiming');
      fleets[cf.id].ap:=0;
      cf.ap:=0;
      field[cf.x,cf.y].o:=-1;
      if (field[cf.x,cf.y].b=1) or (field[cf.x,cf.y].b=4) then field[cf.x,cf.y].b:=0;
    end;
    if (field[cf.x,cf.y].o=-1) and (cf.ap>0) and
       ((moneypool[apl]>=bclmc) or ((plr[apl].team=4) and (moneypool[apl]>=round(bclmc*0.8)))) and
       ((productpool[apl]>=bclpc) or ((plr[apl].team=4) and (productpool[apl]>=round(0.8*bclpc)))) and
       (TileHasNearbyClaimed(cf.x,cf.y,cf.owner)=true) then
    begin
      //showmessage('claiming');
      addpopup(cf.x,cf.y,strarr[54]);
      fleets[cf.id].ap:=0;
      field[cf.x,cf.y].o:=apl;
      cf.ap:=0;
      if plr[apl].team=4 then
        moneypool[apl]:=moneypool[apl]-round(0.8*bclmc)
      else
        moneypool[apl]:=moneypool[apl]-bclmc;
      if plr[apl].team=4 then
        productpool[apl]:=productpool[apl]-round(bclpc*0.8)
      else
        productpool[apl]:=productpool[apl]-bclpc;
    end;
  end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  ClaimCage(fleets[afleet]);
end;

procedure TForm1.ShowMMenu;
VAR tempbmp:TPortableNetworkGraphic;
    topmenubmp:TPortableNetworkGraphic;
    i:integer;
begin
  Log('ShowMMenu proc started');
  globalbmp:=TBitmap.Create;
  tempbmp:=TPortableNetworkGraphic.Create;
  globalbmp.Width:=image1.Width;
  globalbmp.Height:=Image1.Height;
  globalbmp.Canvas.Brush.Color:=clSkyBlue;
  globalbmp.Canvas.Pen.Color:=clSkyBlue;
  globalbmp.Canvas.Rectangle(0,0,globalbmp.Width,globalbmp.Height);
  if Image1.Width<=520 then
    tempbmp.LoadFromFile(extractfiledir(application.ExeName)+'/mainmenu320.png');
  if (Image1.Width>520) and (Image1.Width<=840) then
    tempbmp.LoadFromFile(extractfiledir(application.ExeName)+'/mainmenu640.png');
  if (Image1.Width>840) and (Image1.Width<=1000) then
    tempbmp.LoadFromFile(extractfiledir(application.ExeName)+'/mainmenu800.png');
  if (Image1.Width>1000) then
    tempbmp.LoadFromFile(extractfiledir(application.ExeName)+'/mainmenu1024.png');
  with globalbmp.Canvas do
  begin
    globalbmp.Canvas.CopyRect(rect(round(image1.width/2-tempbmp.Width/2),
                              round(image1.height/2-tempbmp.height/2),
                              round(image1.width/2+tempbmp.Width/2),
                              round(image1.height/2+tempbmp.height/2)),
                         tempbmp.Canvas,
                         rect(0,0,tempbmp.Width,tempbmp.Height));
    //Ellipse();
    for i:=1 to 20 do
    begin
      Pen.Width:=1;
      if buts[i].visible=true then
      begin
        Brush.Style:=bsSolid;
        Pen.Style:=psSolid;
        if buts[i].state=0 then
        begin
          Brush.Color:=clSkyBlue;
          Pen.Color:=clBlack;
          Font.Name:='Courier New';
          Font.Color:=clBlack;
          Font.Style:=[fsBold];
          Font.Size:=abs(round((buts[i].y1-buts[i].y2)/2));
        end;
        if buts[i].state=1 then
        begin
          Brush.Color:=clYellow;
          Pen.Color:=clBlack;
          Font.Name:='Courier New';
          Font.Color:=clBlack;
          Font.Style:=[fsBold];
          Font.Size:=abs(round((buts[i].y1-buts[i].y2)/2));
        end;
        if buts[i].state=2 then
        begin
          Brush.Color:=clRed;
          Pen.Color:=clWhite;
          Font.Name:='Courier New';
          Font.Color:=clWhite;
          Font.Style:=[];
          Font.Size:=abs(round((buts[i].y1-buts[i].y2)/2));
        end;
        RoundRect(buts[i].x1,buts[i].y1,buts[i].x2,buts[i].y2,buts[i].chm,buts[i].chm);
        if buts[i].cb=false then
        begin
          Brush.Style:=bsClear;
          TextOut(buts[i].x1+buts[i].chm,buts[i].y1+1,buts[i].text);
        end;
        if buts[i].cb=true then
        begin
          Brush.Style:=bsClear;
          TextOut(buts[i].x1+buts[i].chm+(abs((buts[i].y1+1)-(buts[i].y2-1)))+1,
                  buts[i].y1+1,buts[i].text);
          Brush.Style:=bsSolid;
          Brush.Color:=clWhite;
          Rectangle(buts[i].x1+buts[i].chm,buts[i].y1+1,
                    buts[i].x1+buts[i].chm+(abs((buts[i].y1+1)-(buts[i].y2-1))),
                    buts[i].y2-1);
          if buts[i].cbc=true then
          begin
            Brush.Style:=bsSolid;
            Brush.Color:=clBlack;
            Ellipse(buts[i].x1+buts[i].chm+1,buts[i].y1+2,
                      buts[i].x1+buts[i].chm+(abs((buts[i].y1+2)-(buts[i].y2-2))),
                      buts[i].y2-2);
          end;
        end;
        Font.Style:=[];
        Font.Color:=clBlack;
        Brush.Style:=bsSolid;
      end;
    end;
  end;
  Image1.Canvas.CopyRect(rect(round(image1.width/2-globalbmp.Width/2),
                              round(image1.height/2-globalbmp.height/2),
                              round(image1.width/2+globalbmp.Width/2),
                              round(image1.height/2+globalbmp.height/2)),
                         globalbmp.Canvas,
                         rect(0,0,globalbmp.Width,globalbmp.Height));


  //--New game window--
  if form2.Visible=true then
  begin
    Form2.CheckBox3.Checked:=plr[Form2.ComboBox1.ItemIndex].human;
    if plr[Form2.ComboBox1.ItemIndex].human=true then
         Form2.Label5.Caption:=strarr[55]
    else Form2.Label5.Caption:=strarr[56];
    with Form2.Image1.Canvas do
    begin
      Pen.Color:=clBlack;
      Brush.Color:=plr[Form2.ComboBox1.ItemIndex].color;
      Rectangle(0,0,width,height);
      CopyRect(rect(0,0,width,height),
               bsspritesl[plr[form2.combobox1.ItemIndex].team].Canvas,
               rect(0,0,bsspritesl[plr[form2.combobox1.ItemIndex].team].Width,
               bsspritesl[plr[form2.combobox1.ItemIndex].team].Height));
    end;
    Form2.Edit6.Text:=plr[Form2.ComboBox1.ItemIndex].name;
    if ((plr[Form2.ComboBox1.ItemIndex].team)<(Form2.ComboBox3.Items.Count)) and
       ((plr[Form2.ComboBox1.ItemIndex].team)>(-1)) then
       //Form2.ComboBox3.Text:=Form2.ComboBox3.Items[plr[Form2.ComboBox1.ItemIndex].team]
    else
    begin
      plr[Form2.ComboBox1.ItemIndex].team:=random(sno);
    end;
    //elements names locales

  end;
  if form13.Visible=true then
  begin
    {with Form13.Image1.Canvas do
    begin
      Pen.Color:=clBlack;
      Brush.Color:=plr[Form2.ComboBox1.ItemIndex].color;
      Rectangle(0,0,width,height);
      CopyRect(rect(0,0,width,height),
               bsspritesl[plr[form2.combobox1.ItemIndex].team].Canvas,
               rect(0,0,bsspritesl[plr[form2.combobox1.ItemIndex].team].Width,
               bsspritesl[plr[form2.combobox1.ItemIndex].team].Height));
    end;}


  end;
  //ending
  //Application.ProcessMessages;
  freeandnil(globalbmp);
  freeandnil(tempbmp);
  with Form2 do
  begin
    Caption:=strarr[162];
    GroupBox1.Caption:=strarr[67];
    GroupBox2.Caption:=strarr[58];
    GroupBox3.Caption:=strarr[61];
    GroupBox4.Caption:=strarr[75];
    GroupBox5.Caption:=strarr[70];
    GroupBox6.Caption:=strarr[101];
    Label1.Caption:=strarr[93];
    Label2.Caption:=strarr[59];
    Label3.Caption:=strarr[60];
    Label4.Caption:=strarr[62];
    Label6.Caption:=strarr[63];
    Label7.Caption:=strarr[64];
    Label8.Caption:=strarr[68];
    Label9.Caption:=strarr[76];
    Label10.Caption:=strarr[77];
    Label11.Caption:=strarr[78];
    Label12.Caption:=strarr[79];
    Label13.Caption:=strarr[80];
    Label14.Caption:=strarr[81];
    Label15.Caption:=strarr[71];
    Label16.Caption:=strarr[72];
    Label17.Caption:=strarr[82];
    Label19.Caption:=strarr[83];
    Label20.Caption:=strarr[84];
    Label21.Caption:=strarr[85];
    Label22.Caption:=strarr[86];
    Label23.Caption:=strarr[87];
    Label24.Caption:=strarr[88];
    Label26.Caption:=strarr[65];
    Label27.Caption:=strarr[133];
    Label29.Caption:=strarr[113];
    Label30.Caption:=strarr[134];
    Label31.Caption:=strarr[142];
    Label32.Caption:=strarr[143];
    Label33.Caption:=strarr[144];
    Label34.Caption:=strarr[145];
    Label36.Caption:=strarr[146];

    CheckBox1.Caption:=strarr[73];
    CheckBox2.Caption:=strarr[74];
    CheckBox3.Caption:=strarr[66];
    CheckBox4.Caption:=strarr[90];
    CheckBox5.Caption:=strarr[135];
    CheckBox6.Caption:=strarr[153];
    Button1.Caption:=strarr[69];
    Button2.Caption:=strarr[94];
    Button3.Caption:=strarr[92];
    Button4.Caption:=strarr[91];
    Button5.Caption:=strarr[92];
    SpeedButton1.Caption:='?';
    {try
      If ComboBox3.Text='' then
        ComboBox3.Text:=ComboBox3.Items[plr[ComboBox1.ItemIndex].team];
    except end;}
  end;
  with form13 do
  begin
    Label1.Caption:=strarr[157];
    Label2.Caption:=strarr[158];
    Button1.Caption:=strarr[161];
    Button2.Caption:=strarr[159];
    Button3.Caption:=strarr[160];
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  //maxf:=getmaxf;
  Log('Timer 1 cycle');
  if mm=true then
  begin
    Panel1.Enabled:=false;
    buts[1].visible:=false;
    buts[2].visible:=false;
    buts[3].visible:=false;
    buts[4].visible:=false;
    buts[5].visible:=false;
    buts[6].visible:=false;
    buts[7].visible:=false;
    buts[8].visible:=false;
    buts[9].visible:=false;
    buts[10].visible:=false;
    buts[11].visible:=false;
    buts[12].visible:=false;
    buts[13].visible:=true;
    buts[14].visible:=false;
    buts[15].visible:=false;
    buts[16].visible:=false;
    //buts[17].visible:=false;
    //buts[18].visible:=false;
    //buts[19].visible:=false;
    //buts[20].visible:=false;
    with buts[17] do
    begin
      y1:=30;
      y2:=50;
      x1:=30;
      x2:=230;
      visible:=true;
      text:=strarr[148];
      cb:=false;
    end;
    with buts[18] do
    begin
      y1:=70;
      y2:=90;
      x1:=30;
      x2:=230;
      visible:=true;
      text:=strarr[139];
      cb:=false;
    end;
    with buts[19] do
    begin
      y1:=110;
      y2:=130;
      x1:=30;
      x2:=230;
      visible:=true;
      text:=strarr[140];
      cb:=false;
    end;
    with buts[20] do
    begin
      y1:=150;
      y2:=170;
      x1:=30;
      x2:=230;
      visible:=true;
      text:=strarr[138];
      cb:=false;
    end;
    ShowMMenu;
//    buts[10].visible:=false;
  end
  else
  begin
    if cm=true then
    begin
      bt:=bt+1;
      if bt>1000 then bt:=1;
      //ShowBattle(bp1,bpf1,bab1,bdb1,bc1,cbt1,bp2,bpf2,bab2,bdb2,bc2,cbt2,bt);
    end else bt:=0;
    if lpop>32000 then cleanpopups;
    processpopups;
    {buts[1].visible:=true;
    buts[2].visible:=true;
    buts[3].visible:=true;
    buts[4].visible:=true;
    buts[5].visible:=true;
    buts[6].visible:=true;
    buts[7].visible:=true;
    buts[8].visible:=true;
    buts[9].visible:=false;
    buts[10].visible:=false;}
    buts[17].visible:=false;
    buts[18].visible:=false;
    buts[19].visible:=false;
    buts[20].visible:=false;
    Redraw;
    Panel1.Enabled:=true;
    if maxpl>1 then
      WinCheck;
  end;

end;

procedure TForm1.ShowBattle(p1,bs1,r1:integer;ab1,db1:real;c1:TColor;a1,id1:integer;
                            p2,bs2,r2:integer;ab2,db2:real;c2:TColor;a2,id2:integer;turn:integer);
var i,ii,isu:integer;
    shrestbase:integer;
    putk:integer=0;
    row:integer=0;
    lr:integer;
    //as1,as2:integer;
    rp:integer=0;
    bspd:real;
    pa:integer;
    dnx,dny,ds,cosa,sina:real;
    cmdmg,cbdmg:integer;
    abd,dbd:real;
begin
  //bfw:=1920;
  //bfh:=1080;
  bspd:=bfw/50;
  maxo:=p1+p2;
  bt:=0;
  //Part 1: Arrange fleets
  if bt=0 then
  begin
    et:=0; sr:=true;
    cleanbattledata;
    cm:=true;
    for i:=0 to (maxo-1) do
    begin
      battlefleet[i].tp:=0;
      if i<=(p1-1) then
        battlefleet[i].orient:=1
      else
        battlefleet[i].orient:=2;
      battlefleet[i].alive:=true;
      battlefleet[i].dmbonus:=1;
      battlefleet[i].defbouns:=1;
      battlefleet[i].animframe:=0;
      missiles[i].alive:=false;
      beams[i].alive:=false;
      battlefleet[i].hptxt:='';
    end;
    //arranging fleet 1
    for i:=0 to (p1-1) do
    begin
      with battlefleet[i] do
      begin
        color:=c1;
        hp:=bbasehp;
        shield:=bbasehp;
        ctid:=-1;
        if i<bs1 then
        begin
          tp:=1;
          hp:=round(hp*bbshpmult);
        end;
        y1:=round(bfh/2+putk*(bfh/30)*rp);
        if putk=0 then putk:=1 else putk:=putk*(-1);
        if (y1<round(bfh/20)) or (y1>(bfh-round(bfh/20))) then
        begin
          putk:=0;
          row:=row+30;
          rp:=0;
        end;
        x1:=30+row;
        rp:=rp+1;
        owner:=a1;
        dmbonus:=ab1;
        defbouns:=db1;
      end;
    end;
    //arranging fleet 2
    row:=0;
    putk:=0;
    isu:=0;
    rp:=0;
    for i:=(p1) to (maxo-1) do
    begin
      with battlefleet[i] do
      begin
        color:=c2;
        hp:=bbasehp;
        shield:=bbasehp;
        ctid:=-1;
        if i<(bs2+p1) then
        begin
          tp:=1;
          hp:=round(hp*bbshpmult);
        end;
        y1:=round(bfh/2+putk*(bfh/30)*rp);
        if putk=0 then putk:=1 else putk:=putk*(-1);
        if (y1<0) or (y1>bfh) then
        begin
          putk:=0;
          row:=row+30;
          rp:=0;
        end;
        x1:=bfw-30-row;
        owner:=a2;
        dmbonus:=ab2;
        defbouns:=db2;
      end;
      rp:=rp+1;
      isu:=isu+1;
    end;
  end;

  //COMBAT CYCLE

  repeat
  if bpause=false then begin



  //Part 2: Simulating battle
  if bt>0 then
  begin

    //1. Checking fleet sizes
    as1:=0;
    as2:=0;
    for i:=0 to (maxo-1) do
    begin
      if (battlefleet[i].alive=true) and (battlefleet[i].owner=a1) then as1:=as1+1;
      if (battlefleet[i].alive=true) and (battlefleet[i].owner=a2) then as2:=as2+1;
      //MOVING SHIPS
      with battlefleet[i] do
      begin
        if x1<=0 then x1:=x1+random(5);
        if y1<=0 then y1:=y1+random(5);
        if y1>=bfh then y1:=y1-random(5);
        if x1>=bfw then x1:=x1-random(5);
        if (x1>0) and(x1<bfw) and (y1>0) and (y1<bfh) then
        begin
          x1:=x1+random(round(bfw/150))*(random(3)-1);
          y1:=y1+random(round(bfh/75))*(random(3)-1);
        end;
      end;
      //restoring shields
      with battlefleet[i] do
      begin
        if (shield>0) and (shield<=bbasehp) then
        begin
          shrestbase:=round((bbasehp/250));
          if shrestbase=0 then shrestbase:=1;
          shrestbase:=shrestbase*plr[owner].tech[2];
          shield:=shield+shrestbase;
        end;
        if shield>bbasehp then shield:=bbasehp;
        if (shield<=0) and (random(50)<5) then
        begin
          shield:=1;
        end;

      end;
      //3. Checking if ship used weapons
      with missiles[i] do
      begin
        if (battlefleet[i].alive=true) and (missiles[i].alive=false) then
        begin
          missiles[i].alive:=true;
          {pa:=0;
          repeat
            tid:=Random(p2)+p1;
            pa:=pa+1;
          until (battlefleet[tid].alive=true) or (pa>1000);}
          pa:=0;
          missiles[i].tid:=battlefleet[i].ctid;
          if (battlefleet[battlefleet[i].ctid].alive=false) or (battlefleet[i].ctid=-1) then
          repeat
            tid:=Random(maxo);
            pa:=pa+1;
          until ((battlefleet[tid].alive=true) and (battlefleet[tid].owner<>battlefleet[i].owner)) or (pa>1000);
          if (battlefleet[tid].owner=battlefleet[i].owner) then missiles[i].alive:=False;
          battlefleet[i].ctid:=tid;
          xr:=battlefleet[i].x1;
          yr:=battlefleet[i].y1;
          //bxr[i]:=xr;
          //byr[i]:=yr;
          x1:=round(xr);
          y1:=round(yr);
          tx:=battlefleet[tid].x1;
          ty:=battlefleet[tid].y1;
          spd:=bspd;
          kx:=spd;
          {if ((ty-battlefleet[i].y1)=0) or ((tx-battlefleet[i].x1)=0) then kx:=10 else
            kx:=spd*(abs(ty-battlefleet[i].y1)/abs(tx-battlefleet[i].x1));
          if ((ty-battlefleet[i].y1)=0) or ((tx-battlefleet[i].x1)=0) then ky:=0 else
            ky:=spd*((tx-battlefleet[i].x1)/(ty-battlefleet[i].y1));}
        end
        else
        begin
          kx:=spd;
          spd:=spd+0.1;
          dnx:=tx-battlefleet[i].x1;
          dny:=ty-battlefleet[i].y1;
          ds:=sqrt(sqr(dnx)+sqr(dny));
          if ds=0 then ds:=bfw;
          cosa:=dnx/ds;
          sina:=dny/ds;
          kx:=abs(spd*cosa);
          ky:=abs(spd*sina);
          if dnx<0 then kx:=(-1)*kx;
          if dny<0 then ky:=(-1)*ky;
          xr:=xr+kx;
          yr:=yr+ky;
          x1:=round(xr);
          y1:=round(yr);
          if ((x1>=battlefleet[tid].x1-spd) and (x1<=battlefleet[tid].x1+spd) and
             (y1>=battlefleet[tid].y1-spd) and (y1<=battlefleet[tid].y1+spd))  then
          begin
            if (battlefleet[missiles[i].tid].alive=true) then
            begin
              cmdmg:=round(bbasedmg);
              if battlefleet[i].tp=1 then cmdmg:=round(cmdmg*bbshpmult);
              if ballowrandom=true then cmdmg:=Random(cmdmg)+1;
              abd:=cmdmg*0.05*plr[a1].tech[0]+cmdmg*(battlefleet[i].dmbonus-1);
              dbd:=cmdmg*0.05*plr[a2].tech[2]+cmdmg*(battlefleet[missiles[i].tid].defbouns-1);
              cmdmg:=round(cmdmg+abd-dbd);
              if battlefleet[missiles[i].tid].shield<=0 then
              begin
                battlefleet[missiles[i].tid].hp:=battlefleet[missiles[i].tid].hp-cmdmg;
                battlefleet[missiles[i].tid].hptxt:=IntToStr(cmdmg)+'+'+floattostr(abd)+'-'+floattostr(dbd);
              end
              else
              begin
                battlefleet[missiles[i].tid].shield:=battlefleet[missiles[i].tid].shield-cmdmg;
                battlefleet[missiles[i].tid].hptxt:='s'+IntToStr(cmdmg);
              end;
              if  battlefleet[missiles[i].tid].hp<=0 then
              begin
                battlefleet[missiles[i].tid].alive:=false;
                if battlefleet[missiles[i].tid].tp=1 then fleets[id2].battleships:=fleets[id2].battleships-1;
                battlefleet[missiles[i].tid].animframe:=7;
              end;
            end;
            missiles[i].alive:=false;
          end;
          if (x1>=bfw) or (x1<=0) then missiles[i].alive:=false;
        end;
      end;
      with plasma[i] do
      begin
        if (battlefleet[i].alive=true) and (plasma[i].alive=false) then
        begin
          plasma[i].alive:=true;
          animstep:=0;
          pa:=0;
          plasma[i].tid:=battlefleet[i].ctid;
          if (battlefleet[battlefleet[i].ctid].alive=false) or (battlefleet[i].ctid=-1) then
          repeat
            tid:=Random(maxo);
            pa:=pa+1;
          until ((battlefleet[tid].alive=true) and (battlefleet[tid].owner<>battlefleet[i].owner)) or (pa>1000);
          if (battlefleet[tid].owner=battlefleet[i].owner) then plasma[i].alive:=False;
          //if plasma[];
          battlefleet[i].ctid:=tid;
          xr:=battlefleet[i].x1;
          yr:=battlefleet[i].y1;
          //bxr[i]:=xr;
          //byr[i]:=yr;
          x1:=round(xr);
          y1:=round(yr);
          tx:=battlefleet[tid].x1;
          ty:=battlefleet[tid].y1;
          spd:=round(bspd/2);
          kx:=spd;
          {if ((ty-battlefleet[i].y1)=0) or ((tx-battlefleet[i].x1)=0) then kx:=10 else
            kx:=spd*(abs(ty-battlefleet[i].y1)/abs(tx-battlefleet[i].x1));
          if ((ty-battlefleet[i].y1)=0) or ((tx-battlefleet[i].x1)=0) then ky:=0 else
            ky:=spd*((tx-battlefleet[i].x1)/(ty-battlefleet[i].y1));}
        end
        else
        begin
          kx:=spd;
          spd:=spd+0.1;
          dnx:=tx-battlefleet[i].x1;
          dny:=ty-battlefleet[i].y1;
          ds:=sqrt(sqr(dnx)+sqr(dny));
          if ds=0 then ds:=bfw;
          cosa:=dnx/ds;
          sina:=dny/ds;
          kx:=abs(spd*cosa);
          ky:=abs(spd*sina);
          if dnx<0 then kx:=(-1)*kx;
          if dny<0 then ky:=(-1)*ky;
          xr:=xr+kx;
          yr:=yr+ky;
          x1:=round(xr);
          y1:=round(yr);
          if ((x1>=battlefleet[tid].x1-spd) and (x1<=battlefleet[tid].x1+spd) and
             (y1>=battlefleet[tid].y1-spd) and (y1<=battlefleet[tid].y1+spd))  then
          begin
            if (battlefleet[plasma[i].tid].alive=true) then
            begin
              cmdmg:=round(bbasedmg*2);
              if battlefleet[i].tp=1 then cmdmg:=round(cmdmg*bbshpmult);
              if ballowrandom=true then cmdmg:=Random(cmdmg)+1;
              abd:=cmdmg*0.05*plr[a1].tech[0]+(cmdmg*(battlefleet[i].dmbonus-1));
              dbd:=cmdmg*0.05*plr[a2].tech[2]+(cmdmg*(battlefleet[plasma[i].tid].defbouns-1));
              cmdmg:=round(cmdmg+abd-dbd);
              if battlefleet[plasma[i].tid].shield<=0 then
              begin
                battlefleet[plasma[i].tid].hp:=battlefleet[plasma[i].tid].hp-cmdmg;
                battlefleet[plasma[i].tid].hptxt:=IntToStr(cmdmg)+'+'+floattostr(abd)+'-'+floattostr(dbd);
              end
              else
              begin
                battlefleet[plasma[i].tid].shield:=battlefleet[plasma[i].tid].shield-cmdmg;
                battlefleet[plasma[i].tid].hp:=battlefleet[plasma[i].tid].hp-round(cmdmg/(round(2)+2));
                battlefleet[plasma[i].tid].hptxt:=IntToStr(round(cmdmg/(round(2)+2)))+'+'+floattostr(abd/2)+'-'+floattostr(dbd/2);
              end;
              if  battlefleet[plasma[i].tid].hp<=0 then
              begin
                battlefleet[plasma[i].tid].alive:=false;
                if battlefleet[plasma[i].tid].tp=1 then fleets[id2].battleships:=fleets[id2].battleships-1;
                battlefleet[plasma[i].tid].animframe:=7;
              end;
            end;
            plasma[i].alive:=false;
          end;
          if (x1>=bfw)or (x1<=0) then plasma[i].alive:=false;
        end;
      end;
      with beams[i] do
      begin
        if {(beams[i].alive=false) and} (battlefleet[i].alive=true) and (random(3)=1) then
        begin
          beams[i].alive:=true;
          pa:=0;
          beams[i].tid:=battlefleet[i].ctid;
          if (battlefleet[battlefleet[i].ctid].alive=false) or (battlefleet[i].ctid=-1) then
          repeat
            tid:=Random(maxo);
            pa:=pa+1;
          until ((battlefleet[tid].alive=true) and (battlefleet[tid].owner<>battlefleet[i].owner)) or (pa>1000);
          if (battlefleet[tid].owner=battlefleet[i].owner) then beams[i].alive:=False;
          battlefleet[i].ctid:=tid;
          xr:=battlefleet[i].x1;
          yr:=battlefleet[i].y1;
          //bxr[i]:=xr;
          //byr[i]:=yr;
          x1:=round(xr);
          y1:=round(yr);
          x2:=0;
          tx:=battlefleet[tid].x1;
          ty:=battlefleet[tid].y1;
        end;
        if beams[i].alive=true then
        begin
          x2:=x2+1;
          if x2=1 then
            color:=clYellow;
          if x2=2 then
            color:=RGBToColor(255,155,0);
          if x2=3 then
            color:=clRed;
          if x2=4 then
            color:=clMaroon;
          if Random((x2+1)*100)=0 then
          begin
            cbdmg:=round(bbdmg+(bbdmg*0.05*plr[a1].tech[1])-(bbdmg*0.05*plr[a2].tech[2]));
            if battlefleet[i].tp=1 then cbdmg:=round(cbdmg*bbshpmult);
            if ballowrandom=true then cbdmg:=Random(cbdmg)+1;
            cbdmg:=round(cbdmg*battlefleet[i].dmbonus);
            cbdmg:=round(cbdmg/battlefleet[tid].defbouns);
            if battlefleet[tid].shield<=0 then
            begin
              battlefleet[tid].hp:=battlefleet[tid].hp-cmdmg;
              battlefleet[tid].hptxt:=IntToStr(cmdmg)+'!!!';
            end
            else
            begin
              battlefleet[tid].shield:=battlefleet[tid].shield-cmdmg;
              battlefleet[tid].hptxt:=' ';
            end;

            if  battlefleet[tid].hp<=0 then
            begin
              battlefleet[tid].alive:=false;
              if battlefleet[tid].tp=1 then fleets[id2].battleships:=fleets[id2].battleships-1;
              battlefleet[tid].animframe:=7;
            end;
          end;
          if x2=5 then alive:=false;
        end;
      end;
      //Redraw;
    end;

    Redraw;
    //2. Stopping battle conditions
    if et=1 then
    begin
      cm:=false;
      sleep(1000)
    end;
    if ((as1<=r1) or (as2<=r2)) or (et<>0) then
    begin
      et:=1;
      if CheckBox5.Checked=true then
      begin
        sr:=true;
        //Redraw;
      end;
      //sleep(2000);
      //cm:=false;
    end;

    {pa:=0;
    if (as1<=0) and (r1>0) then
    begin
      for i:=0 to (r1-1) do
      begin
        if pa<=(r1-1) then battlefleet[i].alive:=true;
        pa:=pa+1;
      end;
    end;
    pa:=0;
    if (as2<0) and (r2>0) then
    begin
      for i:=p1 to (maxo-1) do
      begin
        if pa<=(r2-1) then battlefleet[i].alive:=true;
        pa:=pa+1;
      end;
    end;}
  end;


  //this ens id for PAUSE
  end;

  Application.ProcessMessages;

  until (cm=false);
end;

procedure TForm1.MoveFleet(flt,kx,ky:integer);
var efid,f1p,f2p,f1d,f2d,prc1,prc2:integer;
    abta1,abta2:real;
begin
  Log('MoveFleet issued...');
  if (fleets[flt].owner=apl) and (fleets[flt].ap>0) and (checkforfleet(fleets[flt].x+kx,fleets[flt].y+ky).owner=-1) and
     (fleets[flt].x+kx>=0) and (fleets[flt].x+kx<=(gw-1)) and (fleets[flt].y+ky>=0) and (fleets[flt].y+ky<=(gh-1))then
  begin
    //showmessage('move');
    fleets[flt].ap:=fleets[flt].ap-1;
    fleets[flt].x:=fleets[flt].x+kx;
    fleets[flt].y:=fleets[flt].y+ky;
  end;
  if (fleets[flt].owner=apl) and (fleets[flt].ap>0) and (checkforfleet(fleets[flt].x+kx,fleets[flt].y+ky).owner<>apl) and
     (fleets[flt].x+kx>=0) and (fleets[flt].x+kx<=(gw-1)) and (fleets[flt].y+ky>=0) and (fleets[flt].y+ky<=(gh-1)) and
     (checkforfleet(fleets[flt].x+kx,fleets[flt].y+ky).owner<>-1) then
  begin
    //showmessage('attack');
    efid:=checkforfleet(fleets[flt].x+kx,fleets[flt].y+ky).id;
    prc1:=round(fleets[efid].power+(fleets[efid].battleships*bbshpmult));
    prc2:=round(fleets[flt].power+(fleets[flt].battleships*bbshpmult));
    if ballowrandom=false then
    begin
      f1d:=prc1;
      f2d:=prc2;
    end
    else
    begin
      f1d:=random(prc1+1);
      f2d:=random(prc2+1);
    end;
    f1d:=round(f1d*(fleets[efid].ab/fleets[flt].db));
    f2d:=round(f2d*(fleets[flt].ab/fleets[efid].db));
    f1d:=round(f1d+(f1d*0.05*(plr[fleets[efid].owner].tech[0]+plr[fleets[efid].owner].tech[1])-
         (f1d*0.05*plr[fleets[flt].owner].tech[2])));
    f2d:=round(f2d+(f2d*0.05*(plr[fleets[flt].owner].tech[0]+plr[fleets[flt].owner].tech[1])-
         (f2d*0.05*plr[fleets[efid].owner].tech[2])));
    if (field[fleets[efid].x,fleets[efid].y].b=4) and (field[fleets[efid].x,fleets[efid].y].o=fleets[efid].owner) then
    begin
      f1d:=round(f1d*1.25);
    end;
    if (field[fleets[flt].x,fleets[flt].y].b=4) and (field[fleets[flt].x,fleets[flt].y].o=fleets[flt].owner) then
    begin
      f2d:=round(f2d*1.25);
    end;
    f1p:=round(fleets[flt].power-f1d);
    f2p:=fleets[efid].power-f2d;
    if f1p<0 then f1p:=0;
    if f2p<0 then f2p:=0;
    if CheckBox4.Checked=true then
    begin
      bbgn:=Random(bgno);
      bp1:=fleets[flt].power;
      bp2:=fleets[efid].power;
      bpf1:=f1p;
      bpf2:=f2p;
      bab1:=fleets[flt].ab;
      bab2:=fleets[efid].ab;
      bdb1:=fleets[flt].db;
      bdb2:=fleets[efid].db;
      bc1:=plr[fleets[flt].owner].color;
      bc2:=plr[fleets[efid].owner].color;
      cbt1:=fleets[flt].owner;
      cbt2:=fleets[efid].owner;
      abta1:=fleets[flt].ab;
      if (field[fleets[flt].x,fleets[flt].y].b=4) and (field[fleets[flt].x,fleets[flt].y].o=fleets[flt].owner) then
      begin
        abta1:=(abta1*1.25);
      end;
      abta2:=fleets[efid].ab;
      if (field[fleets[efid].x,fleets[efid].y].b=4) and (field[fleets[efid].x,fleets[efid].y].o=fleets[efid].owner) then
      begin
        abta2:=(abta2*1.25);
      end;
      if (plr[fleets[flt].owner].human=true) or
         (plr[fleets[efid].owner].human=true) then
      begin
        bpause:=true
      end
      else
      begin
        bpause:=false;
      end;
      ShowBattle(fleets[flt].power,fleets[flt].battleships,
                 f1p,abta1,fleets[flt].db,
                 plr[fleets[flt].owner].color,fleets[flt].owner,fleets[flt].id,
                 fleets[efid].power,fleets[efid].battleships,
                 f2p,abta2,fleets[efid].db,
                 plr[fleets[efid].owner].color,fleets[efid].owner,fleets[efid].id,0);

      repeat
        Application.ProcessMessages;
      until cm=false;
      if CheckBox5.Checked=true then
      begin
        f1p:=as1;
        f2p:=as2;
        f1d:=fleets[flt].power-f1p;
        f2d:=fleets[efid].power-f2p;
      end;
    end;
    addpopup(fleets[flt].x,fleets[flt].y,inttostr(f1d));
    addpopup(fleets[efid].x,fleets[efid].y,inttostr(f2d));
    fleets[flt].power:=f1p;
    fleets[efid].power:=f2p;
    fleets[flt].xp:=fleets[flt].xp+f2d;
    fleets[efid].xp:=fleets[efid].xp+f1d;
    //removing bs
    if (fleets[flt].battleships>fleets[flt].power) then fleets[flt].battleships:=fleets[flt].power;
    if (fleets[efid].battleships>fleets[flt].power) then fleets[flt].battleships:=fleets[efid].power;
    //giving levels
    if (fleets[flt].power>0) and (fleets[flt].xp>=power(10,fleets[flt].level)) then
    begin
      fleets[flt].level:=fleets[flt].level+1;
      if random(2)=0 then fleets[flt].ab:=fleets[flt].ab+0.1
      else fleets[flt].db:=fleets[flt].db+0.1;
      addpopup(fleets[flt].x,fleets[flt].y,strarr[100]+' '+inttostr(fleets[flt].level));
    end;
    if (fleets[efid].power>0) and (fleets[efid].xp>=power(10,fleets[efid].level)) then
    begin
      fleets[efid].level:=fleets[efid].level+1;
      if random(2)=0 then fleets[efid].ab:=fleets[efid].ab+0.1
      else fleets[efid].db:=fleets[efid].db+0.1;
      addpopup(fleets[efid].x,fleets[efid].y,strarr[100]+' '+inttostr(fleets[flt].level));
    end;
    //killin' dead
    if fleets[flt].power<=0 then fleets[flt].owner:=-1;
    if fleets[efid].power<=0 then fleets[efid].owner:=-1;
    fleets[flt].ap:=fleets[flt].ap-1;
  end;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key=VK_ESCAPE then MenuItem1.Click;
  if mm=false then
  begin
    if cm=false then
    begin
      if key=VK_RETURN then EndTurn;
      if key=VK_UP then MoveFleet(afleet,0,-1);
      if key=VK_DOWN then MoveFleet(afleet,0,1);
      if key=VK_LEFT then MoveFleet(afleet,-1,0);
      if key=VK_Right then MoveFleet(afleet,1,0);
      if Key=VK_SPACE then ClaimCage(fleets[afleet]);
      if Key=VK_NUMPAD7 then UpgradeTile(acagex,acagey);
      if key=VK_TAB then
      begin
        if fleets[afleet].owner=apl then UpgradeFleet(afleet);
        if fleets[afleet].owner=-1 then BuildNewFleet(acagex,acagey,apl,plr[apl].fleetcost);
      end;
    end;
    if cm=true then
    begin
      if key=VK_TAB then
      begin
        bselship:=bselship+1;
        if bselship>maxo then bselship:=0;
        //if plr[battlefleet[bselship].owner].human=false then
      end;
      if (key=VK_CONTROL) and (plr[battlefleet[bselship].owner].human=true) then
      begin
        battlefleet[bselship].ctid:=battlefleet[bselship].ctid+1;
        if battlefleet[bselship].ctid>maxo then battlefleet[bselship].ctid:=0;
        if (battlefleet[battlefleet[bselship].ctid].owner<>battlefleet[bselship].owner) then
        repeat
          battlefleet[bselship].ctid:=battlefleet[bselship].ctid+1;
          if battlefleet[bselship].ctid>maxo then battlefleet[bselship].ctid:=0;
        until (battlefleet[battlefleet[bselship].ctid].owner<>battlefleet[bselship].owner);
      end;
      if key=VK_SPACE then
      begin
        if bpause=true then bpause:=false else bpause:=true;
      end;
    end;
  end;

end;

procedure Tform1.WinCheck;
var n,i,j,wp:integer;
    lfo:integer=-1;
    gotwin:boolean;
begin
  Log('Checking vic conditions...');
  if (mm=false) and (Form11.Visible=false) and (Form10.Visible=false) then
  begin
    gotwin:=false;
    if viccond=1 then
    begin
      if (field[vc_x,vc_y].o<>-1) and (plr[field[vc_x,vc_y].o].human=true) then
      begin
        gotwin:=true;
        wp:=field[vc_x,vc_y].o;
      end;
    end;
    if viccond=2 then
    begin
      if fleets[vc_id].owner=-1 then
      begin
        gotwin:=true;
        wp:=apl;
      end;
    end;
    if viccond=3 then
    begin
      if turn=vc_t then
      begin
        gotwin:=true;
        wp:=apl;
      end;
    end;

    n:=0;
    for i:=0 to (gw-1) do
    for j:=0 to (gh-1) do
    begin
      if field[i,j].o<>-1 then
      begin
        if lfo=-1 then
        begin
          lfo:=field[i,j].o;
          n:=1;
        end;
        if lfo<>field[i,j].o then n:=n+1;
      end;
    end;
    if ((lfo<>-1) and (n=1)) or (gotwin=true) then
    begin
      if (nmid='') or (fileexists(Extractfiledir(application.ExeName)+'\'+nmid)=false) then
      begin
        try
          cleangamedata;
        except end;
        if (lfo<>-1) then wp:=lfo;
        mm:=true;
        ig:=False;
        plr[0].human:=true;
        maxpl:=1;
        MessageDlg(strarr[27]+' '+inttostr(wp)+strarr[57],mtInformation,[mbOK],0);
      end
      else
      begin
        LoadGame(Extractfiledir(application.ExeName)+'\'+nmid);
      end;
    end;
  end;
end;

procedure TForm1.SpeedButton10Click(Sender: TObject);
begin
  MoveFleet(afleet,0,-1);
end;

procedure TForm1.SpeedButton11Click(Sender: TObject);
begin
  SetGameScl(-1);
end;

procedure TForm1.CheckBox1Change(Sender: TObject);
begin
  ego:=CheckBox1.Checked;
end;

procedure TForm1.SpeedButton12Click(Sender: TObject);
begin
    MoveFleet(afleet,0,1);
end;

procedure TForm1.SpeedButton13Click(Sender: TObject);
begin
    MoveFleet(afleet,1,-1);
end;

procedure TForm1.SpeedButton14Click(Sender: TObject);
begin
    MoveFleet(afleet,1,0);
end;

procedure TForm1.SpeedButton15Click(Sender: TObject);
begin
    MoveFleet(afleet,1,1);
end;

procedure TForm1.SpeedButton16Click(Sender: TObject);
begin
  Form8.Show;
end;

procedure TForm1.SpeedButton17Click(Sender: TObject);
begin
  AddBattleship(afleet);
end;

procedure TForm1.SpeedButton17DblClick(Sender: TObject);
begin

end;

procedure TForm1.SpeedButton71Click(Sender: TObject);
begin
  SetGameScl(1);
end;

procedure TForm1.SpeedButton70Click(Sender: TObject);
begin
    MoveFleet(afleet,-1,-1);
end;

procedure TForm1.SpeedButton7Click(Sender: TObject);
begin
  Form4.Show;
end;

procedure TForm1.SpeedButton8Click(Sender: TObject);
begin
    MoveFleet(afleet,-1,0);
end;

procedure TForm1.SpeedButton9Click(Sender: TObject);
begin
    MoveFleet(afleet,-1,1);
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  scl:=TrackBar1.Position;
end;

procedure TForm1.AudioNote(id:integer);
var sn:PAnsiChar;
begin
  case id of
  1:begin
      //start game
      sn:=PChar(extractfiledir(application.exename)+'/'+inttostr(id)+'.wav');
      PlaySound(sn,0,SND_FILENAME);
    end;
  end;
end;

procedure TForm1.CheckBox2Change(Sender: TObject);
begin
  dsp:=CheckBox2.Checked;
end;

end.

