unit ulocale;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, ugomain;

type

  { TForm7 }

  TForm7 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Memo1: TMemo;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure LoadLocales(lid,tp:integer);
    procedure SaveLocales(lid:integer);
    procedure ReadLocales;
    procedure Button3Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form7: TForm7;

implementation

{$R *.lfm}

{ TForm7 }

uses unewgame;

function oemtolocal(s:string):string;
var str:utf8string;
i,j:integer;
oem:string;
loc:string;
ex:boolean;
begin
oem:='';
oem:=oem+#128;oem:=oem+#129;oem:=oem+#130;oem:=oem+#131;oem:=oem+#132;
oem:=oem+#133;oem:=oem+#134;oem:=oem+#135;oem:=oem+#136;oem:=oem+#137;
oem:=oem+#138;oem:=oem+#139;oem:=oem+#140;oem:=oem+#141;oem:=oem+#142;
oem:=oem+#143;oem:=oem+#144;oem:=oem+#145;oem:=oem+#146;oem:=oem+#147;
oem:=oem+#148;oem:=oem+#149;oem:=oem+#150;oem:=oem+#151;oem:=oem+#152;
oem:=oem+#153;oem:=oem+#154;oem:=oem+#155;oem:=oem+#156;oem:=oem+#157;
oem:=oem+#158;oem:=oem+#159;oem:=oem+#160;oem:=oem+#161;oem:=oem+#162;
oem:=oem+#163;oem:=oem+#164;oem:=oem+#165;oem:=oem+#166;oem:=oem+#167;
oem:=oem+#168;oem:=oem+#169;oem:=oem+#170;oem:=oem+#171;oem:=oem+#172;
oem:=oem+#173;oem:=oem+#174;oem:=oem+#175;oem:=oem+#224;oem:=oem+#225;
oem:=oem+#226;oem:=oem+#227;oem:=oem+#228;oem:=oem+#229;oem:=oem+#230;
oem:=oem+#231;oem:=oem+#232;oem:=oem+#233;oem:=oem+#234;oem:=oem+#235;
oem:=oem+#236;oem:=oem+#237;oem:=oem+#238;oem:=oem+#239;
loc:='АБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюя';
str := '';
for i:=1 to length(s) do begin
ex:=false;
for j:=1 to length(oem) do begin
if s[i] = oem[j] then begin
str := str + loc[(j-1)*2+1]+loc[(j-1)*2+2]; //брать по 2 байта
ex:=true;
break;
end;
end;
if not ex then str := str + s[i];
end;
result := str;
end;

procedure TForm7.LoadLocales(lid,tp:integer);
var allow:boolean;
begin
  Edit1.Text:=inttostr(lid);
  if tp=0 then
    if MessageDlg(strarr[111],mtConfirmation,[mbYes,mbNo],0)=mryes then allow:=true else allow:=false
  else
    allow:=true;
  if allow=true then
  with form7 do
  begin
    Memo1.Lines.LoadFromFile(ExtractFileDir(Application.ExeName)+'\locales\locale_'+inttostr(lid)+'.txt');
  end;
 // Memo1.Text:=oemtolocal(Memo1.Text);
end;

procedure TForm7.Button1Click(Sender: TObject);
begin
  SaveLocales(strtoint(Edit1.Text));
end;

procedure TForm7.ReadLocales;
var i:integer;
    f: TextFile; // файл
    fName: String[80]; // имя файла
    buf: string[80]; // буфер для чтения из файла
begin
  for i:=0 to (Memo1.Lines.Count-1) do
  begin
    strarr[i]:=Memo1.Lines[i];
  end;
  cloc:=strtoint(Edit1.Text);
  with form2 do
  begin
    ComboBox3.Items.Clear;
    for i:=0 to (sno-1) do
    begin
      fName := ExtractFileDir(Application.ExeName)+'\sprites\'+inttostr(i)+'_'+inttostr(cloc)+'.txt';
      //ShowMessage('Reading file: '+ExtractFileDir(Application.ExeName)+'\sprites\'+inttostr(i)+'_'+inttostr(cloc)+'.txt');

      AssignFile(f, fName);
      Reset(f); // открыть для чтения


      if IOResult <> 0 then
      begin
        {MessageDlgt 'Ошибка доступа к файлу ' + fName,
          mtError, [mbOk], 0); exit;}
      end;

      // чтение из файла
      while not EOF(f) do
      begin
        readln(f, buf); // прочитать строку из файла
        ComboBox3.Items.Add(buf); // добавить строку в поле Memo1
      end;
      CloseFile(f); // закрыть файл
    end;
  end;

end;

procedure TForm7.Button2Click(Sender: TObject);
begin
  ReadLocales;
end;

procedure TForm7.SaveLocales(lid:integer);
begin
  if MessageDlg(strarr[112],mtConfirmation,[mbYes,mbNo],0)=mryes then
  with form7 do
  begin
    Memo1.Lines.SaveToFile(ExtractFileDir(Application.ExeName)+'\locales\locale_'+inttostr(lid)+'.txt');
  end;
end;

procedure TForm7.Button3Click(Sender: TObject);
begin
  LoadLocales(strtoint(Edit1.Text),0);
end;

end.

