unit ustat;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, TAGraph, TASeries, Forms, Controls, Graphics,
  Dialogs, StdCtrls, ugomain;

type

  { TForm3 }

  TForm3 = class(TForm)
    Chart1: TChart;
    Chart1LineSeries1: TLineSeries;
    Memo1: TMemo;
    function Calculateprosperity(plr:integer; addlines:boolean; sp:boolean):integer;
    procedure InitStatChart;
    procedure FormShow(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form3: TForm3;
  statseries:array[0..10]of TLineSeries;

implementation

{$R *.lfm}

{ TForm3 }

procedure TForm3.InitStatChart;
var i:integer;
begin
  //Chart1.Legend.GroupTitles.Clear;
  for i:=0 to (maxpl-1) do
  begin
    statseries[i]:=TLineSeries.Create(Form3.Chart1);
    statseries[i].LinePen.Color := plr[i].color;
    statseries[i].Title:=plr[i].name;
    if plr[i].name='' then statseries[i].Title:=strarr[27]+' '+inttostr(i);
    Chart1.AddSeries(statseries[i]);
  end;
end;

function TForm3.Calculateprosperity(plr:integer; addlines:boolean; sp:boolean):integer;
var i,ii,jj,tc,fp,p,p1,p2:integer;
begin
    if addlines=true then Memo1.Lines.Clear;
    if addlines=true then Memo1.Lines.Add(strarr[106]+strarr[107]+strarr[108]+strarr[109]+strarr[110]);
    if sp=true then
    begin
      p1:=plr; p2:=plr;
    end
    else
    begin
      p1:=0; p2:=maxpl-1;
    end;
    for i:=p1 to p2 do
    begin
      if addlines=true then Memo1.Lines.Add('--'+strarr[27]+' '+inttostr(i)+'--');
      tc:=0; fp:=0;
      for ii:=0 to (gw-1) do
      for jj:=0 to (gh-1) do
        if field[ii,jj].o=i then tc:=tc+field[ii,jj].m+field[ii,jj].p;
      for ii:=1 to 4000 do
        if fleets[ii].owner=i then fp:=fp+fleets[ii].power;
      if addlines=true then Memo1.Lines.Add(' '+strarr[28]+' : '+inttostr(tc));
      if addlines=true then Memo1.Lines.Add(' '+strarr[29]+'     : '+inttostr(fp));
      p:=tc*(fp+round(moneypool[i]/1000)+round(productpool[i]/1000));
      if addlines=true then Memo1.Lines.Add(' '+strarr[30]+': '+inttostr(p));
    end;
    result:=p;
end;

procedure TForm3.FormShow(Sender: TObject);
begin
  Calculateprosperity(0,true,false);
end;

procedure TForm3.Memo1Change(Sender: TObject);
begin

end;

end.

