unit utrade;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, TAGraph, TASeries, Forms, Controls, Graphics,
  Dialogs, ExtCtrls, StdCtrls, Buttons, ComCtrls, ugomain;

type

  { TForm4 }

  TForm4 = class(TForm)
    Button1: TButton;
    Chart1: TChart;
    Chart1LineSeries1: TLineSeries;
    Edit1: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox5: TGroupBox;
    Image1: TImage;
    Image2: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    ListBox1: TListBox;
    Memo1: TMemo;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    TrackBar1: TTrackBar;
    procedure GetExustingBldg;
    procedure ListBox1Click(Sender: TObject);
    procedure Loadbuildinginfo(blid:integer);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure GroupBox4Click(Sender: TObject);
    procedure InitChart;
    procedure SellProduct(amount:integer);
    procedure BuyProduct(amount:integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form4: TForm4;
  priceseries:TLineSeries;
  psx:integer;

implementation

{$R *.lfm}

{ TForm4 }

procedure TForm4.GetExustingBldg;
var pt,txs:string;
    ii:integer=0;
begin
  ListBox1.Clear;
  pt:=ExtractFileDir(Application.ExeName)+'\buildings\';
  txs:=Memo1.Text;
  repeat
    ii:=ii+1;
    if FileExists(pt+'bldgid_'+inttostr(ii)+'_'+inttostr(cloc)+'.txt')=true then
    begin
      Memo1.Lines.LoadFromFile(pt+'bldgid_'+inttostr(ii)+'_'+inttostr(cloc)+'.txt');
      ListBox1.Items.Add(Memo1.Lines[0]);
    end;
    //else ShowMessage('No such bldg. Quitting!');
  until (fileexists(pt+'bldgid_'+inttostr(ii)+'_'+inttostr(cloc)+'.txt')=false);
  Memo1.Text:=txs;
end;

procedure TForm4.ListBox1Click(Sender: TObject);
begin
  Loadbuildinginfo(ListBox1.ItemIndex+1);
end;

procedure TForm4.Loadbuildinginfo(blid:integer);
var pt:string;
    bldgview:TPortableNetworkGraphic;
    i2w,i2h:integer;
begin
  pt:=ExtractFileDir(Application.ExeName)+'\buildings\';
  if fileexists(pt+'bldg_'+inttostr(blid)+'_'+inttostr(cloc)+'.txt')=true then
    Memo1.Lines.LoadFromFile(pt+'bldg_'+inttostr(blid)+'_'+inttostr(cloc)+'.txt')
  else
    Memo1.Text:='-';
  if FileExists(pt+'bldg_'+inttostr(blid)+'.png')=true then
  begin
    bldgview:=TPortableNetworkGraphic.Create;
    bldgview.LoadFromFile(pt+'bldg_'+inttostr(blid)+'.png');
    i2h:=Image2.Height;
    i2w:=Image2.Width;
    Image2.Canvas.CopyRect(rect(0,0,i2w,i2h),bldgview.Canvas,rect(0,0,i2w,i2h));
    freeandnil(bldgview);
  end;
end;

procedure TForm4.SellProduct(amount:integer);
var totp:integer;
begin
  totp:=pprice*amount;
  if plr[apl].team=0 then totp:=round(totp*1.1);
  if productpool[apl]>=amount then
  begin
    moneypool[apl]:=moneypool[apl]+totp;
    productpool[apl]:=productpool[apl]-amount;
    pprice:=pprice-round(random(amount)/10);
    if pprice<minpprice then pprice:=minpprice;
  end;
end;

procedure TForm4.BuyProduct(amount:integer);
var totp:integer;
begin
  totp:=pprice*amount;
  if moneypool[apl]>=totp then
  begin
    if plr[apl].team<>0 then
      moneypool[apl]:=moneypool[apl]-totp
    else
      moneypool[apl]:=moneypool[apl]-round(0.9*totp);
    productpool[apl]:=productpool[apl]+amount;
    pprice:=pprice+round(random(amount)/10);
    if pprice>maxpprice then pprice:=maxpprice;
  end;
end;

procedure TForm4.InitChart;
begin
  priceseries:=TLineSeries.Create(Form4.Chart1);
  priceseries.LinePen.Color := clRed;
  Chart1.AddSeries(priceseries);
end;

procedure TForm4.FormShow(Sender: TObject);
var pw,ph,i1w,i1h:integer;
begin
  TrackBar1.Position:=plr[apl].sperc;
  globalpng:=TPortableNetworkGraphic.Create;
  globalpng.LoadFromFile(extractfiledir(Application.ExeName)+'/tradeguild_logo.png');
  pw:=globalpng.Width;
  ph:=globalpng.Height;
  i1w:=Image1.Width;
  i1h:=Image1.Height;
  Image1.Canvas.Brush.Color:=clSkyBlue;
  Image1.Canvas.Pen.Color:=clSkyBlue;
  Image1.Canvas.Rectangle(0,0,Image1.Width,Image1.Height);
  Image1.Canvas.CopyRect(Rect(round((i1w/2)-(pw/2)),
                              round((i1h/2)-(ph/2)),
                              round((i1w/2)+(pw/2)),
                              round((i1h/2)+(ph/2))),
                         globalpng.Canvas,
                         Rect(0,0,pw,ph));
  FreeAndNil(globalpng);
  GetExustingBldg;
  Loadbuildinginfo(field[acagex,acagey].b);
end;

procedure TForm4.GroupBox4Click(Sender: TObject);
begin

end;

procedure TForm4.Button1Click(Sender: TObject);
begin
  if field[acagex,acagey].b>0 then
    Form1.deconstructbuilding(acagex,acagey,0,apl)
  else
    Form1.constructbuilding(acagex,acagey,ListBox1.ItemIndex+1,apl);
end;

procedure TForm4.SpeedButton1Click(Sender: TObject);
var totp:integer;
begin
  SellProduct(strtoint(Edit1.Text));
end;



procedure TForm4.SpeedButton2Click(Sender: TObject);
begin
  BuyProduct(strtoint(Edit1.Text));
end;

procedure TForm4.SpeedButton3Click(Sender: TObject);
begin
  Edit1.Text:=inttostr(productpool[apl]);
end;

procedure TForm4.TrackBar1Change(Sender: TObject);
begin
  plr[apl].sperc:=TrackBar1.Position;
end;

end.

